---
layout: page
title: "Документация"
lang: bg
---

Тук ще намерите връзки към ръководства, самоучители и различни източници
на информация, свързани с изучаването и усъвършенстването на Ruby.
{: .summary}

### Инсталиране на Ruby

Освен ако не искате да пробвате Ruby във вашият браузър (линкът е по-долу),
трябва да инсталирате Ruby на вашият компютър.
Може да проверите дали Ruby е вече инсталиран като отворите терминал
и напишете:

{% highlight sh %}
ruby -v
{% endhighlight %}

Ако е инсталиран ще бъде изведена информация за инсталираната версия.
В противен случай вижте [страницата за инсталиране](installation/)
за подробни инструкции за инсталиране.

### Като за начало

[Try Ruby!][1]
: Интерактивно ръководство за Ruby в твоят браузър. Препоръчва се за начинаещи,
  които искат да се запознаят с езика.

[Ruby Koans][2]
: Коаните помагат с научаването на синтаксиса и структурата на Ruby,
  както и със запознаването с някои основни функции и библиотеки.

[Why’s (Poignant) Guide to Ruby][5]
: Необичайна, но интересна книга, която ще ви научи на Ruby чрез
  истории, шеги и рисунки. Първоначално създадено от *why the lucky stiff*,
  това ръководство остава класика при ученето на Ruby.

[Ruby in Twenty Minutes](/bg/documentation/quickstart/)
: Кратък туториал, покриващ основите на Ruby. Отнема не повече от 20 минути.

[Ruby from Other Languages](/bg/documentation/ruby-from-other-languages/)
: Идвате от друг език? Независимо дали е C, C++, Java, Perl, PHP или
  Python, тази страница е за вас!

[Ruby Essentials][7]
: Ruby Essentials е безплатна on-line книга, предоставяща лесен начин за
  научаването на Ruby.

[Learn to Program][8]
: Чудесно ръководство за начинаещи Ruby програмисти от Chris Pine.

[Learn Ruby the Hard Way][38]
: Много добър набор от упражнения с обяснения, които покриват всичко от
  от основите до ООП и разработката на web приложения.

### Ръководства

[Programming Ruby][9]
: Първото издание на книгата [Pragmatic Programmers][10], напълно
  безплатно.

[The Ruby Programming Wikibook][12]
: Безплатно online ръководство със съдържание за начинаещи и средно
  напреднали.

### Документация

[Ruby Core Reference][13]
: Официалната документация, извлечена от сорс кода чрез [RDoc][14]. Тук
  можете да намерите информация за всички вградени класове и модули
  (като String, Array, Symbol, и.т).

[Ruby Standard Library Reference][15]
: Документация, също извлечена от сорс кода, описваща стандартната
  библиотека на Ruby.

[RubyDoc.info][16]
: Документация за Ruby gem-ове и Ruby проекти, хоствани в github.com

[Ruby & Rails Searchable API Docs][17]
: Rails и Ruby документация с възможност за умно търсене.

[APIdock][18]
: Документация за Ruby, Rails и RSpec, включваща потребителски забележки и
  коментари.

### Редактори и среди за разработка

За писане на Ruby може да бъде използван всеки редактор на текст. За
по-голяма ефективност се препоръчва използването на редактор с вградена
поддръжка на Ruby (напр. оцветяване на кода, автоматично подравняване)
или интегрирана среда за разработка (IDE) с повече функционалности (напр.
допълване на код, рефакторинг, дебъгер).

Списък с най-популярните приложения, използвани от Ruby разработчици:

* Linux и мултиплатформени приложения:
  * [Aptana Studio][19]
  * [Emacs][20] с [Ruby mode][21] и [Rsense][22]
  * [Geany][23]
  * [gedit][24]
  * [Vim][25] с плъгина [vim-ruby][26] и [Rsense][22]
  * [RubyMine][27]
  * [SciTe][28]
  * [NetBeans][36]
  * [Sublime Text][37]
  * [Visual Studio Code][vscode] с плъгина [Ruby LSP][40]

* За Windows:
  * [Notepad++][29]

* За macOS:
  * [TextMate][32]
  * [BBEdit][33]
  * [Dash][39] (за преглед на документация)

### Други източници

[Ruby-Doc.org][34] поддържа списък с източници на информация на
английски език.
Ако имате въпроси относно Ruby, [пощенският списък](/bg/community/mailing-lists/)
е чудесно място да ги зададете.

[1]: https://try.ruby-lang.org/
[2]: https://rubykoans.com/
[5]: https://poignant.guide
[7]: http://www.techotopia.com/index.php/Ruby_Essentials
[8]: http://pine.fm/LearnToProgram/
[9]: http://www.ruby-doc.org/docs/ProgrammingRuby/
[10]: http://pragmaticprogrammer.com/titles/ruby/index.html
[12]: http://en.wikibooks.org/wiki/Ruby_programming_language
[13]: http://www.ruby-doc.org/core
[14]: https://ruby.github.io/rdoc/
[15]: http://www.ruby-doc.org/stdlib
[16]: http://www.rubydoc.info/
[17]: http://rubydocs.org/
[18]: http://apidock.com/
[19]: http://www.aptana.com/
[20]: http://www.gnu.org/software/emacs/
[21]: http://www.emacswiki.org/emacs/RubyMode
[22]: http://rsense.github.io/
[23]: http://www.geany.org/
[24]: http://projects.gnome.org/gedit/screenshots.html
[25]: http://www.vim.org/
[26]: https://github.com/vim-ruby/vim-ruby
[27]: http://www.jetbrains.com/ruby/
[28]: http://www.scintilla.org/SciTE.html
[29]: http://notepad-plus-plus.org/
[32]: http://macromates.com/
[33]: https://www.barebones.com/products/bbedit/
[34]: http://ruby-doc.org
[36]: https://netbeans.org/
[37]: http://www.sublimetext.com/
[38]: https://learncodethehardway.org/ruby/
[39]: http://kapeli.com/dash
[vscode]: https://code.visualstudio.com/
[40]: https://marketplace.visualstudio.com/items?itemName=Shopify.ruby-lsp
