---
layout: page
title: "Dokumentation"
lang: de
---

Hier findest du Links zu Handbüchern, Tutorials und Referenzen, die beim
Ruby-Programmieren sicher nützlich sein werden.
{: .summary}

### Erste Schritte

[Try Ruby!][1]
: Ein interaktives Tutorial für Anfänger, ursprünglich von Why the Lucky
  Stiff. Es ist nicht nötig, Ruby zu installieren, denn dieses ca.
  15-minütige Tutorial erlaubt es, Ruby-Code direkt im Browser
  einzugeben! (englisch)

[Why’s (Poignant) Guide to Ruby][3]
: Ein unorthodoxes Buch um Ruby zu lernen.

[Ruby in zwanzig Minuten](/de/documentation/quickstart/)
: Ein kleines Tutorial zu den Grundlagen von Ruby. 20 Minuten sollten
  ausreichen.

[Ruby für Umsteiger](/de/documentation/ruby-from-other-languages/)
: Du willst von einer anderen Programmiersprache auf Ruby umsteigen?
  Egal ob C, C++, Java, Perl, PHP, oder Python – dieser Artikel ist für
  Dich!

[Programmieren lernen mit Ruby][4]
: Ein wunderbares kleines Tutorial, um Programmieren zu lernen, mit Ruby
  als erster Sprache. Wenn Du Anfänger bist, dann starte hier. Deutsche
  Übersetzung der populären englischen Einführung [Learn To Program][5].

### Anleitungen

[Programming Ruby][6]
: Dies ist die erste Auflage des bekannten Pickaxe-Buches der
  Pragmatic Programmers. Es ist kostenlos im Internet verfügbar (englisch).

[Programmieren mit Ruby][8]
: Ein deutschsprachiges Buch zum Thema Ruby von Armin Roehrl, Stefan
  Schmiedl und Clemens Wyss. Es steht vollständig kostenlos im Internet
  zur Verfügung.

### Referenzdokumentation

[Referenz zu Rubys Standardklassen][9]
: Dies ist die Referenz-Dokumentation des Rubykerns. Es handelt sich
  hierbei um eine aus dem Quelltext generierte Dokumentation (englisch).

[Referenz zu Rubys Standardbibliotheken][10]
: Dies ist die Referenz-Dokumentation der Standardbibliothek. Diese
  Dokumentation wird ebenfalls direkt aus dem Quelltext generiert
  (englisch).

[Referenz zu Rubys C-API][extensions]
: Offizielle C-API-Dokumentation von Ruby. Sie beschreibt die vordefinierten
  Schnittstellen für Erweiterungen in der Programmiersprache C und wie diese
  sowohl von der Ruby- als auch der C-Seite aus verwendet werden.

[RubyDoc.info][12]
: Die Referenzdokumentation für Ruby, Gems und auf GitHub gehostete
  Ruby-Projekte.

### Weitere Informationen

[Ruby-Doc.org][13] ist eine große Quelle von englischsprachigen
Dokumenten zum Thema Ruby. Das [Rubywiki][14] ist ein Wiki mit vielen
deutschsprachigen Artikeln. Für weitergehende Fragen steht eine große
[Community](/de/community/) zur Verfügung.



[1]: https://try.ruby-lang.org/
[3]: https://poignant.guide
[4]: http://www.moccasoft.de/papers/ruby_tutorial
[5]: http://pine.fm/LearnToProgram/
[6]: http://www.ruby-doc.org/docs/ProgrammingRuby/
[8]: http://www.approximity.com/rubybuch2/
[9]: http://www.ruby-doc.org/core
[10]: http://www.ruby-doc.org/stdlib
[extensions]: https://docs.ruby-lang.org/en/master/extension_rdoc.html
[12]: http://www.rubydoc.info/
[13]: http://ruby-doc.org
[14]: http://wiki.ruby-portal.de
