---
layout: news_post
title: Offizielles Snap-Paket für Ruby verfügbar
author: Hiroshi SHIBATA
translator: "Marvin Gülker"
date: 2018-11-08 14:58:28 +0000
lang: de
---

Wir haben das offizielle Snap-Paket für die Programmiersprache Ruby
freigegeben.

[https://snapcraft.io/ruby](https://snapcraft.io/ruby)

Snap ist ein von Canonical entwickeltes Paketierungssystem, das es
erlaubt, ein Programm einschließlich seiner Abhängigkeiten für viele
Linux-Distributionen zu verteilen. Damit wird das Problem behoben,
dass ein Nutzer die aktuelle Ruby-Version nicht aus dem
Standard-Repositorium seines Systems (wie rpm oder apt) installieren
kann.

Mit Ubuntu 16.04 oder neuer kann man das Ruby-Snap-Paket mit dem
folgenden Kommando installieren:

```
sudo snap install ruby --classic
```

(für andere Linux-Distributionen siehe [https://docs.snapcraft.io/installing-snapd/6735](https://docs.snapcraft.io/installing-snapd/6735))

Unser Snap-Paket enthält mehrere Ruby-Versionen gleichzeitig, wofür
wir die „Channel“-Funktionalität von Snap verwenden. Wenn Sie keinen
„Channel“ angeben, wird derzeit standardmäßig 2.5.3 installiert. Wenn Sie
stattdessen Ruby 2.4 wollen, dann können Sie den 2.4er „Channel“ wie
folgt anfordern:

```
sudo snap install ruby --classic --channel=2.4/stable
```

Sie können auch mehrere „Channels“ nutzen. Die folgenden Kommandos
wechseln zu Ruby 2.3:

```
sudo snap switch ruby --channel=2.3/stable
sudo snap refresh
```

Unser Snap-Paket setzt die Umgebungsvariablen `GEM_HOME` und
`GEM_PATH` auf `$HOME/.gem`. Wenn Sie von RubyGems installierte
Kommandozeilenprogramme wie etwa `rails` und `rspec` ausführen wollen,
müssen Sie deshalb die folgende Zeile zu Ihrer Shell-RC-Datei (etwa
`.bashrc`) hinzufügen:

```
eval `ruby.env`
```

Weil `$HOME/.gem` von mehreren Versionen genutzt wird, müssen Sie bei
einem Wechsel der Version die C-Extensions neu kompilieren, indem Sie
das Kommando `gem pristine --extensions` ausführen.

Die erste Version des offiziellen Ruby-Snap-Pakets ist während der
Snapcraft-Konferenz, die vom 6. bis 8. November am Unternehmenssitz
von Canonical in London stattfand, veröffentlicht
worden. Rückmeldungen werden unter [https://github.com/ruby/snap.ruby](https://github.com/ruby/snap.ruby)
entgegengenommen.

Viel Spaß!
