---
layout: page
title: "Community"
lang: en
---

The community that grows up around a programming language is one of its
most important strengths. Ruby has a vibrant and growing community that
is friendly towards people of all skill levels.
{: .summary}

If you are interested in getting involved, here are a couple of places
to start:

[Ruby User Groups](user-groups/)
: Your local Ruby user group is a great place to network with other Ruby
  programmers. Ruby user groups are self-organizing and typically
  feature monthly meetings, a mailing list, a Web site, and if you are
  lucky, frequent codefests.

[Ruby Mailing Lists and Newsgroups](mailing-lists/)
: Ruby has an assortment of lists on different topics and in several
  languages. If you have questions about Ruby, asking them on a mailing
  list is a great way to get answers.

[Ruby Discord Server (invite link)][ruby-discord]
: The Ruby Language Discord Server is a place where you can
  chat with other Rubyists, get help with Ruby questions, or help others.
  Discord is a good entry point for new developers and it is easy to join.

[Ruby on IRC (#ruby)](https://web.libera.chat/#ruby)
: The Ruby Language IRC Channel is a wonderful way to chat with fellow
  Rubyists.

[Ruby Core](ruby-core/)
: Now is a fantastic time to follow Ruby’s development.
  If you are interested in helping with Ruby, start here.

[Ruby Blogs and Newsletters](weblogs/)
: Most activities and updates in the Ruby community are discussed through blogs and newsletters. Here’s a curated list to help you stay connected and informed.

[Ruby Conferences](conferences/)
: Ruby programmers around the world are getting involved in more and
  more conferences, where they get together to share reports on
  work-in-progress, discuss the future of Ruby, and welcome newcomers to
  the Ruby community.

  Additionally, you can visit [rubyvideo.dev](https://www.rubyvideo.dev/) to find videos of Ruby conferences and talks.

[Podcasts](podcasts/)
: If you prefer to listen to discussions about Ruby rather than read,
  you can tune into one of these awesome Ruby podcasts. These Rubyists
  use their podcasts to cover new releases, community news, and
  interview their fellow Ruby developers.

[Ruby Central][ruby-central]
: Ruby Central is a non-profit organization dedicated to supporting the worldwide Ruby community.

[ruby-central]: http://rubycentral.org/
[ruby-discord]: https://discord.gg/ad2acQFtkh
