---
layout: page
title: "Posting Guidelines for the Ruby-Talk Mailing List"
lang: en
---

You should follow these guidelines when posting to the ruby-talk mailing list.
{: .summary}


1. **Always** be friendly, considerate, tactful, and tasteful. We want to
   keep this list hospitable to the growing ranks of newbies, very
   young people, and their teachers, as well as cater to fire breathing
   wizards. :-)

2. Keep your content relevant and easy to follow. Try to keep your
   content brief and to the point, but also try to include all relevant
   information.

   1. The general format guidelines (aka Netiquette) are
      matters of common sense and common courtesy that make life
      easier for third parties to follow along (in real time or when
      perusing archives):

      * **Please note:**
        Include quoted text from previous posts **before** your responses
        and **selectively** quote as much as is relevant.
      * Use **plain text**; don't use HTML, RTF, or Word.
        Most email programs have an option for this; if yours doesn't,
        get a (free) program or use a web-based service that does.
      * Include examples from files as **in-line** text; don't use
        attachments.

   2. If reporting a problem, give **all** the relevant information
      the first time; this isn't the psychic friends newsgroup. :-)

      When appropriate, include:

      * an example (preferably simple) that produces the problem
      * the actual error messages
      * the version of Ruby (`ruby -v`)
      * the OS type and version (`uname -a`)
      * the compiler name and version used to build Ruby

3. Make the subject line maximally informative, so that people who
   should be interested will read your post and so that people who
   wouldn't be interested can easily avoid it.

   **Usefully** describe the contents of your post.

   This is OK:

   * "How can I do x with y on z?"
   * "Problem: did x, expected y, got z."
   * "BUG: doing x with module y crashed z."

   This is **not** OK:

   * "Please help!!!"
   * "Newbie question"
   * "Need Ruby guru to tell me what's wrong"

   These prefixes have become common for subject lines:

   * `[ANN]` (for announcements)
   * `[BUG]` (for bug reports)
   * `[OT]`  (for off-topic, if you must post off-topic)

4. Finally, be considerate: Don't be too lazy. If you are seeking
   information, first make a reasonable effort to look it up. As
   appropriate, check the [Ruby home page][ruby-lang],
   check the [Ruby FAQ][faq] and other documentation,
   use a search engine to search past postings, and so on.


_These guidelines where adopted from the [comp.lang.ruby FAQ][clrFAQ]._



[ruby-lang]: /en/
[faq]: /en/documentation/faq/
[clrFAQ]: http://rubyhacker.com/clrFAQ.html
