---
layout: page
title: "User Groups"
lang: en
---

In the programming community, user groups form support networks for
people interested in certain topics. They are a great place to increase
your skills and network with other programmers. User groups are informal
and their structure varies from group to group. Anyone can form their
own group and set their own rules and schedule
{: .summary}

### Ruby User Groups

If you want to get together with other Ruby programmers, a local user
group may be just the thing. Ruby user groups are entirely devoted to
Ruby. They typically feature monthly meetings, a mailing list, a website,
and if you're lucky, frequent hacking sessions (meetings devoted
to giving people a chance to write Ruby code).

Information about Ruby user groups can be found on various websites:

- [Ruby Meetup Groups on meetup.com][meetup]. A substantial number
  of Ruby User Groups have chosen to make Meetup
  their home. Meetup provides a number of tools for user groups,
  including: private forums, a place for announcements, automated
  meeting reminders, and a nice RSVP system.
- [rubyconferences.org/meetups][rc-meetups] now has a list of Ruby Meetup events
  from around the world.
- There is a [Google Group][meetups-google-group] for Ruby Meetup Organizers
- [OnRuby][onruby] - A number of user groups can also be found at OnRuby. OnRuby is an
  open source platform written in Ruby that can be used to organize
  meetups. It is [available on GitHub][onruby-github].

### Organizing Your Own Group

If you are interested in forming your own group, be sure to find out if
there is already a Ruby user group in your area. Try the meetup organizers
group if you're looking for advice on how to start your own group.



[meetup]: https://www.meetup.com/topics/ruby/
[onruby]: https://www.onruby.eu/
[onruby-github]: https://github.com/phoet/on_ruby
[rc-meetups]: https://rubyconferences.org/meetups/
[meetups-google-group]: https://groups.google.com/g/ruby-meetups
