---
layout: news_post
title: "Ruby 1.9.2-p330 Released"
author: "zzak and hone"
translator:
date: 2014-08-19 01:38:12 +0000
lang: en
---

We have released 1.9.2-p330, the final release of the 1.9.2 series.

Soon after announcing the
[End of Life for 1.9.2 (and 1.8.7)](https://www.ruby-lang.org/en/news/2014/07/01/eol-for-1-8-7-and-1-9-2/),
a critical security regression was found in 1.9.2. This vulnerability has been
assigned the CVE identifier [CVE-2014-6438].

This bug occurs when parsing a long string is using the URI method
`decode_www_form_component`. This can be reproduced by running the following
on vulnerable Rubies:

{% highlight ruby %}
ruby -v -ruri -e'URI.decode_www_form_component "A string that causes catastrophic backtracking as it gets longer %"'
{% endhighlight %}

Since it was found and patched just before the release of 1.9.3, versions of
Ruby 1.9.3-p0 and later are _not_ affected; however versions of Ruby 1.9.2
older than 1.9.2-p330 _are_ affected.

You can read the original report on the bug tracker:
<https://bugs.ruby-lang.org/issues/5149#note-4>

## Download

* <https://cache.ruby-lang.org/pub/ruby/1.9/ruby-1.9.2-p330.tar.bz2>

      SIZE:   9081661 bytes
      MD5:    8ba4aaf707023e76f80fc8f455c99858
      SHA256: 6d3487ea8a86ad0fa78a8535078ff3c7a91ca9f99eff0a6a08e66c6e6bf2040f

* <https://cache.ruby-lang.org/pub/ruby/1.9/ruby-1.9.2-p330.tar.gz>

      SIZE:   11416473 bytes
      MD5:    4b9330730491f96b402adc4a561e859a
      SHA256: 23ef45fdaecc5d6c7b4e9e2d51b23817fc6aa8225a20f123f7fa98760e8b5ca9

* <https://cache.ruby-lang.org/pub/ruby/1.9/ruby-1.9.2-p330.zip>

      SIZE:   12732739 bytes
      MD5:    42d261b28d1b7e500dd3bdbdbfba7fa5
      SHA256: 7a04a028564de7f2ad09f26c8d57fd40fe2b0a6a0e1d9ff7205010ca6e70cea6

We encourage you to upgrade to a stable and maintained
[version of Ruby](https://www.ruby-lang.org/en/downloads/).

[CVE-2014-6438]: https://www.cve.org/CVERecord?id=CVE-2014-6438
