---
layout: page
title: "Documentación"
lang: es
---

Aquí encontrarás vínculos a manuales, tutoriales y material de referencia
que te ayudarán a aprender más sobre Ruby.
{: .summary}

### Instalación de Ruby

Aunque fácilmente puedes [probar Ruby en tu navegador][1], también puedes
leer la [guía de instalación](installation/) para obtener ayuda de
como instalar Ruby.

### Para comenzar

[FAQ oficial](/en/documentation/faq/) (en inglés)
: Respuestas oficiales a las preguntas formuladas con frecuencia.

[Koans en Ruby][2] (en inglés)
: Los Koans te llevan por una ruta de iluminación para aprender Ruby.
  La meta es aprender el lenguaje Ruby, su sintaxis, estructura y algunas
  funciones y librerías comunes.  También te enseñamos cultura.

[Guía Por qué (Poignant) de Ruby][5] (en inglés)
: Un libro no convencional pero interesante que te enseñará Ruby mediante
  cuentos, ingenio y dibujos.  Es una creación original de
  *por qué la tenaz suerte*, esta guía sigue siendo un clásico para
  quienes aprenden Ruby.

[Lo esencial de Ruby][7] (en inglés)
: Lo esencial de Ruby es un libro en línea libre, diseñado para dar una
  guía concisa y fácil de seguir para aprender Ruby.

[Aprende a programar][8] (en inglés)
: Un maravilloso y breve tutorial por Chris Pine para los novatos en la
  programación en general. Si no sabes programar, comienza por aquí.

[Aprende Ruby de la forma dura][38] (en inglés)
: Un muy buen conjunto de ejercicios con explicaciones que te guiarán
  de lo absolutamente básico de Ruby, por todo el camino hasta POO y
  desarrollo web.


### Manuales

[Programando en Ruby][9] (en inglés)
: El libro en inglés de referencia, esta primera edición del
  [libro de los programadores pragmáticos][10] está disponible en línea
  de forma gratuita.


[El wikilibro de programación en Ruby][12] (en ingleś)
: Un manual en línea y libre con contenido para principiantes e intermedios
  junto con una guía de referencia del lenguaje.


### Documentación de referencia (en inglés)

[Documentación oficial del API][docs-rlo-en]
: La documentación oficial para diversas versiones del API, incluyendo
  la versión que actualmente está en desarrollo (trunk).

[Referencia del núcleo de Ruby][13]
: Extraída directamente del código fuente mediante [RDoc][8], esta
  referencia documenta todas las clases y módulos básicos (como String,
  Array, Symbol, etc…).

[Referencia de la Biblioteca Estándar de Ruby][15]
: También extraída del código fuente mediante RDoc, esta referencia
  documenta la biblioteca estándar.

[Referencia de la API C de Ruby][extensions]
: La introducción oficial a la API en C de Ruby.
  Perfecto para quienes quieren escribir extensiones en C
  o apoyar el desarrollo de Ruby.

[RubyDoc.info][16]
: El sitio de parada obligada, con documentación de referencia, respecto
  a las gemas Ruby y a los proyectos Ruby alojados en GitHub.

[Documentos de la API de Ruby y de Rails con facilidad de búsqueda][17]
: Documentación de Rails y Ruby con búsqueda inteligente.

[APIdock][18]
: Documentación de Ruby, Rails y RSpec con notas de los usuarios.

[RubyAPI.org][rubyapi-org]
: Encuentra y navega por las clases, módulos y métodos de Ruby.


### Editores e IDEs

Para programar en Ruby, puedes usar el editor predeterminado de tu sistema
operativo.  Por cierto, para ser más efectivo al programa, vale la pena
elegir un editor de código con soporte básico de Ruby (e.g. resaltado
de sintaxis, navegación de archivos) o un ambiente integrado de
desarrollo con características avanzadas (e.g. completación de código,
refactorización, soporte para pruebas).

Aquí hay una lista de herramientas populares usadas por los
Rubiceros:

* Herramientas para Linux y múltiples plataformas:
  * [Aptana Studio][19]
  * [Emacs][20] con [modo Ruby][21] y [Rsense][22]
  * [Geany][23]
  * [gedit][24]
  * [Vim][25] con [vim-ruby][26] y extensión [Rsense][22]
  * [RubyMine][27]
  * [SciTe][28]
  * [NetBeans][36]
  * [Sublime Text][37]
  * [Atom][atom]
  * [Visual Studio Code][vscode]

* En Windows:
  * [Notepad++][29]

* En macOS:
  * [TextMate][32]
  * [BBEdit][33]
  * [Dash][39] (navegador de documentación)


### Otras lecturas

[Ruby-Doc.org][34] mantiene una extensa lista de fuentes de
documentación en inglés.
Si tiene preguntas sobre Ruby, la
[lista de correo](/es/community/mailing-lists/) es un buen lugar para
comenzar.




[1]: https://try.ruby-lang.org/
[2]: https://rubykoans.com/
[5]: https://poignant.guide
[7]: http://www.techotopia.com/index.php/Ruby_Essentials
[8]: http://pine.fm/LearnToProgram/
[9]: http://www.ruby-doc.org/docs/ProgrammingRuby/
[10]: http://pragmaticprogrammer.com/titles/ruby/index.html
[12]: http://en.wikibooks.org/wiki/Ruby_programming_language
[13]: http://www.ruby-doc.org/core
[14]: https://ruby.github.io/rdoc/
[15]: http://www.ruby-doc.org/stdlib
[extensions]: https://docs.ruby-lang.org/en/master/extension_rdoc.html
[16]: http://www.rubydoc.info/
[17]: http://rubydocs.org/
[18]: http://apidock.com/
[rubyapi-org]: https://rubyapi.org/
[19]: http://www.aptana.com/
[20]: http://www.gnu.org/software/emacs/
[21]: http://www.emacswiki.org/emacs/RubyMode
[22]: http://rsense.github.io/
[23]: http://www.geany.org/
[24]: http://projects.gnome.org/gedit/screenshots.html
[25]: http://www.vim.org/
[26]: https://github.com/vim-ruby/vim-ruby
[27]: http://www.jetbrains.com/ruby/
[28]: http://www.scintilla.org/SciTE.html
[29]: http://notepad-plus-plus.org/
[32]: http://macromates.com/
[33]: https://www.barebones.com/products/bbedit/
[34]: http://ruby-doc.org
[36]: https://netbeans.org/
[37]: http://www.sublimetext.com/
[38]: https://learncodethehardway.org/ruby/
[39]: http://kapeli.com/dash
[docs-rlo-en]: https://docs.ruby-lang.org/en/
[atom]: https://atom.io/
[vscode]: https://code.visualstudio.com/
