---
layout: page
title: "Groupes d'utilisateurs"
lang: fr
---

Les groupes d’utilisateurs sont des mini-réseaux regroupant des
programmeurs par centre d’intérêt ou langue. Rejoindre et participer à
un groupe est une manière très efficace d’améliorer ses compétences et
de rencontrer d’autres programmeurs. Les groupes sont informels, au sens
que leur structure varient d’un groupe à un autre : certains consistent
en une simple liste de diffusion ou un forum, d’autres ont une assise
légale (association…) et organisent éventuellement des rencontres et des
conférences. N’importe qui peut former son propre groupe, y établir ses
propres règles, mais généralement, il sera plus intéressant pour vous de
rejoindre un groupe déjà existant que de lancer une initiative
redondante.
{: .summary}

### Groupes

Pour rencontrer d’autres programmeurs Ruby, un groupe local (au sens de
la géographie) peut être un bon moyen de progresser, à condition d’en
avoir un près de chez vous. Les groupes Ruby sont bien évidemment
dédiés… à Ruby, mais aussi certainement à Ruby On Rails et à la
programmation objet en général : tout dépend du nombre de membres et de
leurs centres d’intérêt. De nombreux groupes proposent des réunions
mensuelles, une liste de diffusion interne pour ses membres, un site web
pour le partage des connaissances et, si vous êtes chanceux, des
réunions et conférences (la mode étant aux barcamp, rencontres autour
d’un verre dans un lieu adapté aux présentations).

[Meetup][meetup]
: Un nombre non négligeable de groupes ont choisi de promouvoir leurs
  évènements chez Meetup. Cet outil propose des services variés
  concernant la gestion d’un groupe, notamment un forum privé, un
  endroit dédié aux annonces, des rappels automatiques pour les réunions
  à venir, ainsi qu’un système de réservation/agenda.

[Paris][3]
: Le groupe d’utilisateurs Paris.rb organise des apéros et des sessions
  de code. N’hésitez pas à vous inscrire à la [liste de diffusion][4]
  pour discuter et être informé des événements parisiens.

[Lyon][5]
: Le groupe Lyon.rb est également très actif et organise des apéros le
  second jeudi de chaque mois. Il a également organisé la conférence
  internationale [Ruby Lugdunum][6].

[Toulouse][7]
: À Toulouse aussi, vous pouvez venir aux apéros Ruby, organisés par
  Toulouse.rb.

[Strasbourg][8]
: [Justine Adam][9] et [Yann Klis][10] sont deux membres très actifs de
  la communauté française et organise régulièrement des événements comme
  les apéros le dernier mardi de chaque mois.

[Rennes][11]
: À Rennes, le groupe d’utilisateur est plus centré sur Rails, d’où le
  nom de Rennes on Rails mais les discussions sur Ruby sont les
  bienvenues.

[Nantes][12]
: Plusieurs rubyistes sont présents à Nantes et bien qu’ils n’aient pas
  de sites web, il leur arrive de se rencontrer pour boire une bière.
  Ces apéros sont généralement annoncés sur la liste de diffusion de
  Ruby France.

[Lille][13]
: Le groupe Ruby Nord organise sur Lille (et la région Nord-Pas-de-Calais)
  des apéros Ruby, des repas Ruby Burgers et des ateliers Rails Mentors.
  Du fait de leur proximité, les groupes Ruby Nord et Ruby Belgium sont
  très régulièrement amenés à échanger lors de rencontres conviviales.

[Marseille][14]
: Le Pastis Ruby Brigade est le groupe d’utilisateurs pour les rubyistes
  du sud de la France.

[Sophia Antipolis][15]
: Le Riviera Ruby Group organise depuis peu des drinkups./dd&gt;

[Montpellier][16]
: Dernier groupe d’utilisateur en date, Montpellier a aussi le droit à
  ses apéros.

[Bordeaux][17]
: Et maintenant, Bordeaux a également ses apéros.

[Orléans][18]
: Orléans devrait bientôt avoir son premier apéro Ruby.

### Votre propre groupe

Si votre ville n’est pas listée sur cette page, tout n’est pas perdu.
Vous pouvez envoyer un mail à contact AT rubyfr DOT org. Nous nous
efforçons de mettre en relation les utilisateurs de Ruby dans toute la
France. Et ça peut également être l’occasion de lancer votre groupe
d’utilisateurs avec l’appui de Ruby France. En plus, vous n’avez pas
d’excuse, Camille Roux a écrit un billet de blog qui explique dans le
détail [comment organiser un apéro Ruby][19].



[meetup]: https://www.meetup.com/topics/ruby/
[3]: https://www.meetup.com/parisrb/
[4]: http://groups.google.com/group/parisrb
[5]: http://lyonrb.fr/
[6]: http://rulu.eu/
[7]: http://toulouserb.org/
[8]: https://www.facebook.com/AperoRubyStrasbourg
[9]: https://twitter.com/#!/toutielicious
[10]: https://twitter.com/#!/yannski
[11]: http://www.rennesonrails.com/
[12]: http://groups.google.com/group/rubyfr-public/
[13]: http://ruby-nord.org/
[14]: https://twitter.com/#!/PastisRB
[15]: http://rivierarb.fr/
[16]: http://www.facebook.com/AperoRubyMontpellier
[17]: http://rubybdx.org/
[18]: https://www.meetup.com/Orleans-rb/
[19]: http://www.camilleroux.com/2011/09/15/comment-organiser-un-apero-ruby/
