---
layout: page
title: "Dokumentasi"
lang: id
---

Panduan, tutorial, dan materi referensi untuk membantu Anda mempelajari Ruby
lebih lanjut
{: .summary}

### Memasang Ruby

Meskipun Anda dapat dengan mudah [mencoba Ruby pada browser Anda][1], Anda juga
dapat membaca [panduan instalasi](installation/) untuk memasang Ruby.

### Mulai

[Official FAQ](/en/documentation/faq/)
: *Frequently asked questions* resmi.

[Ruby Koans][2]
: Ruby Koans memandu Anda sepanjang jalan menuju pencerahan untuk belajar
  Ruby. Tujuannya adalah untuk belajar bahasa Ruby, sintaks, struktur, dan
  beberapa fungsi dan pustaka umum. Kami juga mengajarkan budaya Ruby.

[Why’s (Poignant) Guide to Ruby][5]
: Ini sebuah buku tak konvensional tapi menarik yang akan mengajarkan Anda Ruby
  melalui cerita, humor cerdas, dan komik. Awalnya dibuat oleh *why the lucky
  stiff*, panduan ini tetap klasik untuk pelajar Ruby.

[Ruby Essentials][7]
: Sebuah buku *online* gratis yang dirancang untuk memberikan
  panduan singkat dan mudah diikuti untuk belajar Ruby.

[Learn to Program][8]
: Tutorial kecil yang indah oleh Chris Pine untuk pemula pemrograman. Jika
  Anda tidak tahu bagaimana membuat program, mulai dari sini.

[Learn Ruby the Hard Way][38]
: Sebuah kumpulan latihan yang sangat baik dengan penjelasan yang memandu Anda
  dari semua dasar Ruby hingga OOP dan pengembangan *web*.

### Manual

[Programming Ruby][9]
: Ini salah satu karya penting untuk pemrograman Ruby dalam Bahasa Inggris.
  Edisi pertama [Pragmatic Programmers’ book][10] ini tersedia gratis *online*.

[The Ruby Programming Wikibook][12]
: Manual *online* gratis dengan konten untuk pemula dan menengah ditambah
  referensi bahasa Ruby secara menyeluruh.

### Referensi

[Official API Documentation][docs-rlo-en]
: Dokumentasi API Ruby resmi untuk versi yang berbeda termasuk versi yang
  belum rilis (*trunk*) saat ini.

[Ruby Core Reference][13]
: Diambil langsung dari *source code* Ruby menggunakan [RDoc][14],
  referensi ini mendokumentasikan seluruh *core class* dan *core module*
  (seperti String, Array, Symbol, dll.).

[Ruby Standard Library Reference][15]
: Juga diambil langsung dari *source code* menggunakan RDoc, referensi ini
  mendokumentasikan *library* standar.

[Ruby C API Reference][extensions]
: Pengenalan Ruby C API.
  Bagus jika Anda ingin membuat *extension* C
  atau membantu pengembangan Ruby.

[RubyDoc.info][16]
: Situs *web* lengkap untuk dokumentasi referensi tentang Ruby *gem* dan
  proyek Ruby yang di-*host* di GitHub.

[Ruby & Rails Searchable API Docs][17]
: Dokumentasi Rails dan Ruby yang dilengkapi dengan pencarian cerdas.

[APIdock][18]
: Dokumentasi Ruby, Rails, dan RSpec dengan catatan para pengguna.

[RubyAPI.org][rubyapi-org]
: Pencarian dan penelusuran Ruby *class*, *module*, dan *method* dengan mudah.

### Editor dan IDE

Untuk memprogram Ruby, Anda dapat menggunakan *default editor* dari sistem
operasi Anda. Supaya lebih efektif, alangkah sangat berguna untuk memilih
*editor* dengan dukungan Ruby dasar (misalnya
*syntax-highlighting*, *file browsing*) atau *integrated development environment*
yang memiliki fitur canggih (misalnya *code completion*, *refactoring*,
*testing support*).

Berikut adalah daftar kakas populer yang digunakan oleh para pengguna Ruby:

* Kakas pada Linux dan lintas *platform*:
  * [Aptana Studio][19]
  * [Atom][atom]
  * [Emacs][20] dengan [Ruby mode][21] dan [Rsense][22]
  * [Eric][eric]
  * [Geany][23]
  * [gedit][24]
  * [Kate][kate]
  * [KDevelop][kdevelop]
  * [NetBeans][36]
  * [RubyMine][27]
  * [SciTe][28]
  * [Sublime Text][37]
  * [Vim][25] dengan *plugin* [vim-ruby][26] dan [Rsense][22]
  * [Visual Studio Code][vscode]

* Pada Windows:
  * [Notepad++][29]

* Pada macOS:
  * [TextMate][32]
  * [BBEdit][33]
  * [Dash][39] (documentation browser)

### Bacaan selanjutnya

[Ruby-Doc.org][34] merawat daftar lengkap dokumentasi Bahasa Inggris.
Jika Anda memiliki pertanyaan
tentang Ruby, [milis](/id/community/mailing-lists/)
adalah tempat yang baik untuk memulai.



[1]: https://try.ruby-lang.org/
[2]: https://rubykoans.com/
[5]: https://poignant.guide
[7]: http://www.techotopia.com/index.php/Ruby_Essentials
[8]: http://pine.fm/LearnToProgram/
[9]: http://www.ruby-doc.org/docs/ProgrammingRuby/
[10]: http://pragmaticprogrammer.com/titles/ruby/index.html
[12]: http://en.wikibooks.org/wiki/Ruby_programming_language
[13]: http://www.ruby-doc.org/core
[14]: https://ruby.github.io/rdoc/
[15]: http://www.ruby-doc.org/stdlib
[extensions]: https://docs.ruby-lang.org/en/master/extension_rdoc.html
[16]: http://www.rubydoc.info/
[17]: http://rubydocs.org/
[18]: http://apidock.com/
[rubyapi-org]: https://rubyapi.org/
[19]: http://www.aptana.com/
[20]: http://www.gnu.org/software/emacs/
[21]: http://www.emacswiki.org/emacs/RubyMode
[22]: http://rsense.github.io/
[23]: http://www.geany.org/
[24]: http://projects.gnome.org/gedit/screenshots.html
[25]: http://www.vim.org/
[26]: https://github.com/vim-ruby/vim-ruby
[27]: http://www.jetbrains.com/ruby/
[28]: http://www.scintilla.org/SciTE.html
[29]: http://notepad-plus-plus.org/
[32]: http://macromates.com/
[33]: https://www.barebones.com/products/bbedit/
[34]: http://ruby-doc.org
[36]: https://netbeans.org/
[37]: http://www.sublimetext.com/
[38]: https://learncodethehardway.org/ruby/
[39]: http://kapeli.com/dash
[docs-rlo-en]: https://docs.ruby-lang.org/en/
[atom]: https://atom.io/
[vscode]: https://code.visualstudio.com/
[eric]: https://eric-ide.python-projects.org/
[kdevelop]: https://www.kdevelop.org/
[kate]: https://kate-editor.org/
