---
layout: news_post
title: Ruby snap resmi tersedia
author: Hiroshi SHIBATA
translator: "meisyal"
date: 2018-11-08 14:58:28 +0000
lang: id
---

Kami telah merilis *snap package* dari bahasa Ruby yang resmi.

<https://snapcraft.io/ruby>

Snap adalah sebuah *package system* yang dikembangkan oleh Canonical. Snap
memperbolehkan Anda untuk mendistribusikan sebuah perangkat lunak beserta
*dependency*-nya untuk banyak sistem Linux yang berbeda. Ini memecahkan
masalah pengguna yang tidak dapat memasang Ruby terbaru dari *default
repository* yang ada di sistem mereka, seperti `rpm` atau `apt`.

Pada Ubuntu 16.04 atau setelahnya, Anda dapat memasang Ruby snap dengan
perintah berikut:

```
sudo snap install ruby --classic
```

(Jika Anda menggunakan distribusi Linux lainnya, mohon merujuk ke
<https://docs.snapcraft.io/installing-snapd/6735>.)

snap kami menggunakan fitur "channel" untuk merilis banyak rangkaian Ruby
secara bersamaan. Sebagai contoh, tanpa menentukan sebuah channel, Ruby 2.5.3
saat ini akan dipasang. Tetapi, jika Anda ingin menggunakan Ruby 2.4,
tentukan channel 2.4 sebagai berikut:

```
sudo snap install ruby --classic --channel=2.4/stable
```

Anda juga dapat menggunakan banyak channel. Perintah berikut mengalihkan ke
Ruby 2.3:

```
sudo snap switch ruby --channel=2.3/stable
sudo snap refresh
```

snap kami menetapkan *environment variable* `GEM_HOME` dan `GEM_PATH`
ke `$HOME/.gem`.
Sehingga, jika Anda ingin mengeksekusi perintah yang dipasang oleh gem,
seperti `rails` dan `rspec`, tanpa menggunakan `bundle exec`, Anda harus
menambahkan baris berikut pada berkas shell rc Anda (seperti `.bashrc`):

```
eval `ruby.env`
```

Karena `$HOME/.gem` dibagi ke banyak versi, jika Anda beralih versi dan
menggunakannya, Anda butuh untuk *recompile C extension* menggunakan perintah
`gem pristine --extensions`.

Versi awal dari snap Ruby telah dirilis selama Snapcraft *summit* yang
diadakan di kantor Canonical London pada 6 - 8 November 2018. Umpan balik
apapun dapat dikirim ke <https://github.com/ruby/snap.ruby>.

Nikmati!
