---
layout: page
title: "Documentazione"
lang: it
---

Ecco qualche riferimento a manuali, tutorial e altro materiale che ti
potrà venire comodo quando vorrai programmare in Ruby.
{: .summary}

### Per iniziare

[Try Ruby!][1]
: Un tutorial interattivo che ti dà la possibilità di provare Ruby
  direttamente nel tuo browser. Questo tutorial di 15 minuti è orientato
  a principianti che vogliono dare un’occhiata al linguaggio.

[Ruby Koans][2]
: I Koan ti accompagneranno lungo il sentiero illuminato
  dell’apprendimento di Ruby. Lo scopo è imparare il linguaggio Ruby, la
  sua sintassi, struttura e qualche funzionalità e libreria comune. E
  anche un po’ di cultura.

[Why’s (Poignant) Guide to Ruby][5]
: Un libro poco convenzionale ma interessante che ti insegna ad usare
  Ruby attraverso storie, battute argute e fumetti. Originariamente
  creato da *why the lucky stiff*, questa guida rimane un classico per
  chiunque voglia imparare Ruby.

[Ruby in Venti Minuti](/it/documentation/quickstart/)
: Un tutorial che copre le nozioni di base di Ruby. Non dovresti
  impiegare più di venti minuti per completarlo dall’inizio alla fine.

[Ruby per chi conosce altri linguaggi](/it/documentation/ruby-from-other-languages/)
: Vuoi imparare Ruby e conosci già un’altro linguaggio di
  programmazione? Sia che sia C, C++, Java, Perl PHP o Python, questo
  articolo è quello che fa per te.

[Ruby Essentials][7]
: Ruby Essentials è un libro gratuito online, pensato per essere una
  concisa guida facile da seguire per imparare Ruby. \[in inglese\]

[Imparare a Programmare][39]
: Un meraviglioso mini-tutorial scritto da Chris Pine e tradotto in
  italiano da Duccio Armenise. Adatto a neofiti del mondo della
  programmazione. Se non sai come programmare, inizia qui. È disponibile
  anche [la versione originale inglese][8].

[Learn Ruby the Hard Way][38]
: Una serie di esercizi e spiegazioni che partono dalle basi di Ruby
ed arrivano fino alla programmazione OOP e lo sviluppo web.

### Manuali

[Programming Ruby][9]
: Una pietra miliare tra i libri disponibili su Ruby in inglese. La
  prima edizione del [Pragmatic Programmers’ book][10] è disponibile
  online gratuitamente.

[The Ruby Programming Wikibook][12]
: Un manuale online gratuito per persone con conoscenze di livello base
  o intermedio, contenente anche delle parti di riferimento complete.

### Documentazione di riferimento

[Ruby Core Reference][13]
: Preso direttamente dal codice sorgente usando [RDoc][14], questa
  documentazione descrive tutte le classi e i moduli interni (come
  String, Array, Symbol, ecc…).

[Ruby Standard Library Reference][15]
: Anch'essa generata automaticamente dal codice utilizzando RDoc,
  questa documentazione descrive la libreria standard di Ruby.

[RubyDoc.info][16]
: La prima fermata per documentazione di riferimento su gemme
  e progetti Ruby su GitHub.

[Ruby & Rails Searchable API Docs][17]
: Documentazione ricercabile per Rails e Ruby.

[APIdock][18]
: Documentazione con note degli utenti per Ruby, Rails e RSpec.

### Editors e IDE

Per sviluppare in Ruby puoi usare l'editor di default del tuo sistema
operativo. Per sviluppare in modo più rapido ed efficace, è consigliato
scegliere un editor che abbia il supporto per il codice Ruby
(ad es. syntax-highlighting, ricerca dei file) o un'interfaccia IDE
con funzionalità avanzate (ad es. auto completamento del codice, refactoring,
supporto ai test).

Questa è una lista dei tool più comunemente usati dagli sviluppatori Ruby:

* Tool con supporto Linux e multipiattaforma:
  * [Aptana Studio][19]
  * [Emacs][20] con [Ruby mode][21] e [Rsense][22]
  * [Geany][23]
  * [gedit][24]
  * [Vim][25] con [vim-ruby][26] plugin e [Rsense][22]
  * [RubyMine][27]
  * [SciTe][28]
  * [NetBeans][36]
  * [Sublime Text][37]
  * [Visual Studio Code][vscode] con [Ruby LSP][41] plugin

* Per Windows:
  * [Notepad++][29]

* Per macOS:
  * [TextMate][32]
  * [BBEdit][33]
  * [Dash][40] (Documentation Browser)

### Ulteriori Informazioni

[Ruby-Doc.org][34] mantiene un’esauriente lista di documenti in inglese.
Se hai domande su Ruby la lista
delle [mailing list](/it/community/mailing-lists/) è perfetta per
iniziare.



[1]: https://try.ruby-lang.org/
[2]: https://rubykoans.com/
[5]: https://poignant.guide
[7]: http://www.techotopia.com/index.php/Ruby_Essentials
[8]: http://pine.fm/LearnToProgram/
[9]: http://www.ruby-doc.org/docs/ProgrammingRuby/
[10]: http://pragmaticprogrammer.com/titles/ruby/index.html
[12]: http://en.wikibooks.org/wiki/Ruby_programming_language
[13]: http://www.ruby-doc.org/core
[14]: https://ruby.github.io/rdoc/
[15]: http://www.ruby-doc.org/stdlib
[16]: http://www.rubydoc.info/
[17]: http://rubydocs.org/
[18]: http://apidock.com/
[19]: http://www.aptana.com/
[20]: http://www.gnu.org/software/emacs/
[21]: http://www.emacswiki.org/emacs/RubyMode
[22]: http://rsense.github.io/
[23]: http://www.geany.org/
[24]: http://projects.gnome.org/gedit/screenshots.html
[25]: http://www.vim.org/
[26]: https://github.com/vim-ruby/vim-ruby
[27]: http://www.jetbrains.com/ruby/
[28]: http://www.scintilla.org/SciTE.html
[29]: http://notepad-plus-plus.org/
[32]: http://macromates.com/
[33]: https://www.barebones.com/products/bbedit/
[34]: http://ruby-doc.org
[36]: https://netbeans.org/
[37]: http://www.sublimetext.com/
[38]: https://learncodethehardway.org/ruby/
[39]: https://corsidia.com/materia/programmazione/imparare-a-programmare
[40]: http://kapeli.com/dash
[vscode]: https://code.visualstudio.com/
[41]: https://marketplace.visualstudio.com/items?itemName=Shopify.ruby-lsp
