---
layout: page
title: "Ruby-Talk 메일링 리스트 작성 가이드라인"
lang: ko
---

Ruby-Talk 메일링 리스트에 글을 올릴 때는 다음 가이드라인을 따라야 합니다.
{: .summary}

1. **항상** 친절하고, 사려 깊고, 재치 있고, 센스 있게 행동하세요. 이 목록은
   점점 늘어나는 초보자, 아주 어린 학생들, 그리고 그들의 선생님들에게도
   친절하게 대하고, 불을 뿜는 마법사들에게도 친절하게 대하고 싶어요. ^_^

2. 관련성 있고 따라 하기 쉬운 콘텐츠를 작성하세요. 콘텐츠를 간결하고 핵심만
   담되, 모든 관련 정보를 포함하도록 노력하세요.

   1. 일반 형식 가이드라인(일명 네티켓)은 제3자가 (실시간으로 또는 아카이브를
      열람할 때) 쉽게 따라할 수 있도록 하는 상식적이고 일반적인 예의에 관한
      사항입니다.

      * **주의 사항**
        이전 게시글에서 인용한 텍스트를 응답하기 **전에** 포함하고 관련성이
        있는 만큼만 **선택해서** 인용합니다.
      * HTML, RTF, Word를 사용하지 말고 **일반 텍스트**를 사용하세요. 대부분의
        이메일 프로그램에는 이 옵션이 있으며, 그렇지 않은 경우 무료 프로그램을
        구입하거나 이 기능이 있는 웹 기반 서비스를 이용하세요.
      * 첨부 파일을 사용하지 말고 파일에서 **인라인** 텍스트로 예시를
        포함하세요.

   2. 문제를 신고할 경우, 처음에 관련 정보를 **모두** 알려주세요.
      여기는 초능력자 뉴스 그룹이 아니니까요. ^_^

      적절한 경우 포함하세요.

      * 문제를 생성하는 예제(가급적 간단한 것)
      * 실제 오류 메시지
      * 루비 버전(`ruby -v`)
      * OS 유형 및 버전(`uname -a`)
      * 루비 빌드에 사용된 컴파일러 이름 및 버전

3. 제목을 최대한 정보를 넣어 작성하여 관심을 가져야 하는 사람들이 게시물을
   읽고 관심이 없는 사람들이 쉽게 피할 수 있도록 합니다.

   게시물의 내용을 **유용하게** 설명하세요.

   좋습니다.

   * "How can I do x with y on z?" (y로 x를 z에서 어떻게 하죠?)
   * "Problem: did x, expected y, got z."
     (문제: x를 해서 y를 기대했는데 z가 나왔어요.)
   * "BUG: doing x with module y crashed z."
     (버그: 모듈 y로 x를 수행하면 z가 충돌했습니다.)

   이것은 **안됩니다**.

   * "Please help!!!" (도와줘요!!!)
   * "Newbie question" (초보 질문)
   * "Need Ruby guru to tell me what's wrong"
     (뭐가 틀렸는지 알려줄 Ruby 고수 구함)

   이러한 접두사는 제목에 일반적으로 사용되는 접두사입니다.

   * `[ANN]` (공지)
   * `[BUG]` (버그 리포트)
   * `[OT]`  (주제에서 벗어난 글, 필요하다면..)

4. 마지막으로, 스스로 생각해보세요. 너무 게으르지 마세요. 정보를 찾고 있다면 먼저
   합리적인 노력을 기울여 정보를 찾아보세요. [루비 홈페이지][ruby-lang]을
   확인하고, [루비 FAQ][faq] 및 기타 문서를 확인하고, 검색 엔진을 사용하여
   과거 게시물을 검색하는 등 적절한 방법으로 찾아보세요.

_이 가이드라인은 [comp.lang.ruby FAQ][clrFAQ]에서 발췌한 것입니다._

[ruby-lang]: /ko/
[faq]: /ko/documentation/faq/
[clrFAQ]: http://rubyhacker.com/clrFAQ.html
