---
layout: page
title: "Dokumentacja"
lang: pl
---

Znajdziesz tutaj odnośniki do podręczników, tutoriali i materiałów
źródłowych, które okażą się pomocne kiedy będziesz chciał pisać w Ruby.
{: .summary}

### Na początek

[Wypróbuj Ruby!][1]
: Interaktywny tutorial, który pozwoli ci wypróbować Rubiego bezpośrednio
  w twojej przeglądarce internetowej. Ten 15 minutowy tutorial jest
  przeznaczony dla początkujących, którzy chcą zorientować się w języku.

[Ruby Koans][2]
: Koany poprowadzą cię wzdłuż ścieżki do oświecenia, aby poznać Rubiego.
  Celem jest nauczenie się języka Ruby, składni, struktury i
   pewnych popularnych funkcji i bibliotek. Nauczenie również kultury.

[Why’s (Poignant) Guide to Ruby][5]
: Niekonwencjonalna ale interesująca książka, która nauczy cię Rubiego
  poprzez historyjki, dowcipy i komiks. Oryginalnie stworzona przez
  *why the lucky stiff*. Ten przewodnik stał się klasyką dla uczących się
  Rubiego.

[Ruby w 20 minut](/pl/documentation/quickstart/)
: Przyjemny tutorial obejmujący podstawy programowania w Rubim. Od
  początku do końca, nie powinien zająć więcej jak dwadzieścia minut.

[Ruby a inne języki programowania](/pl/documentation/ruby-from-other-languages/)
: Przybywasz z innego języka programowania do Rubiego? Niezależnie
  od tego czy jest to C, C++, Java, Perl, PHP lub Python, ten artykuł z
  pewnością Ci pomoże!

[Ruby Essentials][7]
: Ruby Essentials to darmowa książka zaprojektowana by dostarczać
  zwięzłe i łatwe do naśladowania porady do nauki Rubiego.

[Learn to Program][8]
: Wspaniały mały tutorial napisany przez Chrisa Pine dla nowicjuszy w
  dziedzinie programowania. Jeśli nie wiesz jak programować, zacznij od
  niego.

[Learn Ruby the Hard Way][38]
: Bardzo dobry zbiór ćwiczeń z wyjaśnieniami, który prowadzi cię od
  absolutnych podstaw Rubiego całą drogę do OOP i projektowania stron.

[Ruby Intro][pl-1]
: Polski materiał prezentacyjny przeznaczony dla osób, które znają już
  podstawy programowania i mają pojęcie o programowaniu zorientowanym
  obiektowo.

### Manuale

[Programming Ruby][9]
: Pionierska praca o Rubim w języku angielskim, jej pierwsze wydanie
  [Pragmatic Programmers’ book][10] jest do ściągnięcia za darmo. Drugie
  wydanie książki zostało wydane w języku polskim pod tytułem:
  "Programowanie w języku Ruby".

[The Ruby Programming Wikibook][12]
: Darmowy manual z materiałem dla początkujących i średnio zaawansowanych
  wraz z dokładnymi odniesieniami.

### Dokumentacja referencyjna

[Ruby Core Reference][13]
: Dokumentacja wygenerowana przy pomocy [RDoc][14] prosto z kodu
  źródłowego, opisuje wszystkie klasy i moduły języka (String, Array,
  Symbol, itd).

[Ruby Standard Library Reference][15]
: Wygenerowana również z kodu źródłowego przy pomocy RDoc, dokumentacja
  zawierająca opis biblioteki standardowej.

[RubyDoc.info][16]
: Strona internetowa z dokumentacją referencyjną gemów Rubiego i
  utrzymywanych na GitHubie projektów Rubiego.

[Ruby & Rails Searchable API Docs][17]
: Dokumentacja Railsów i Rubiego ze sprytnym wyszukiwaniem.

[APIdock][18]
: Dokumentacja Rubiego, Railsów i RSpeca z komentarzami użytkowników.

### Edytory i zintegrowane środowiska programistyczne (IDE)

Dla pisania w Rubim możesz używać domyślnego edytora systemu operacyjnego.
Nawiasem mówiąc, by być bardziej efektywnym, warto wybrać edytor z
obsługą i wsparciem dla składni Rubiego (np. kolorowaniem składni,
przeglądaniem plików) lub zintegrowane środowisko programistyczne z
zaawansowanymi funkcjami (np. uzupełnianiem kodu, refaktoryzacją,
wsparciem testowania).

Oto lista popularnych narzędzi używanych przez rubistów:

* Dla Linuxa i wieloplatformowe narzędzia:
  * [Aptana Studio][19]
  * [Emacs][20] z [Ruby mode][21] i [Rsense][22]
  * [Geany][23]
  * [gedit][24]
  * [Vim][25] z wtyczką [vim-ruby][26] i [Rsense][22]
  * [RubyMine][27]
  * [SciTe][28]
  * [NetBeans][36]
  * [Sublime Text][37]
  * [Visual Studio Code][vscode] z wtyczką [Ruby LSP][40]

* Dla Windows:
  * [Notepad++][29]

* Dla macOS:
  * [TextMate][32]
  * [BBEdit][33]
  * [Dash][39] (przeglądarka dokumentacji)

### Inne źródła

[Ruby-Doc.org][34] zawiera kompletną listę dokumentacji języka Ruby w
języku angielskim. Jeśli nadal masz jakieś pytania, możesz je zadać na
[liście dyskusyjnej](/en/community/mailing-lists/) (w języku
angielskim).

Jeśli szukasz pomocy w języku polskim, zajrzyj na [forum][pl-2].

[1]: https://try.ruby-lang.org/
[2]: https://rubykoans.com/
[5]: https://poignant.guide
[7]: http://www.techotopia.com/index.php/Ruby_Essentials
[8]: http://pine.fm/LearnToProgram/
[9]: http://www.ruby-doc.org/docs/ProgrammingRuby/
[10]: http://pragmaticprogrammer.com/titles/ruby/index.html
[12]: http://en.wikibooks.org/wiki/Ruby_programming_language
[13]: http://www.ruby-doc.org/core
[14]: https://ruby.github.io/rdoc/
[15]: http://www.ruby-doc.org/stdlib
[16]: http://www.rubydoc.info/
[17]: http://rubydocs.org/
[18]: http://apidock.com/
[19]: http://www.aptana.com/
[20]: http://www.gnu.org/software/emacs/
[21]: http://www.emacswiki.org/emacs/RubyMode
[22]: http://rsense.github.io/
[23]: http://www.geany.org/
[24]: http://projects.gnome.org/gedit/screenshots.html
[25]: http://www.vim.org/
[26]: https://github.com/vim-ruby/vim-ruby
[27]: http://www.jetbrains.com/ruby/
[28]: http://www.scintilla.org/SciTE.html
[29]: http://notepad-plus-plus.org/
[32]: http://macromates.com/
[33]: https://www.barebones.com/products/bbedit/
[34]: http://ruby-doc.org
[36]: https://netbeans.org/
[37]: http://www.sublimetext.com/
[38]: https://learncodethehardway.org/ruby/
[39]: http://kapeli.com/dash
[pl-1]: http://www.apohllo.pl/dydaktyka/ruby/intro/
[pl-2]: http://forum.rubyonrails.pl/
[vscode]: https://code.visualstudio.com/
[40]: https://marketplace.visualstudio.com/items?itemName=Shopify.ruby-lsp
