---
layout: page
title: "Udane Wdrożenia"
lang: pl
---

Wielu ludzi używa Rubiego na co dzień w swojej pracy. Inni traktują go
bardziej jako hobby. Poniżej znajdziecie kilka przykładów zastosowania
Rubiego w rzeczywistości.
{: .summary}

#### Symulacje

* [Centrum Badań NASA][1] używa Rubiego do przeprowadzania symulacji.
  [Więcej…][2]

* Grupa badawcza w [Motoroli][3] używa Rubiego do budowy symulatora,
  zarówno do wygenerowania scenariuszy jak i do przetwarzania danych.

#### Biznes

* [Toronto Rehab][4] używa aplikacji webowej opartej na RubyWebDialogs
  do zarządzania i śledzenia działu wsparcia technicznego i działu
  operacyjnego.

#### Robotyka

* W projekcie MORPHA, Ruby został użyty do implementacji systemu
  kontroli reakcji Robota usługowego firmy Siemens.

#### Telefonia

* Lucent używa Rubiego w swoim produkcie telefonii bezprzewodowej
  3G.

#### Administracja Systemami

* Ruby został wykorzystany do implementacji centralnego systemu
  zbierania danych w [Level 3 Communications][8] Unix Capacity and
  Planning, systemu który gromadzi statystyki wydajności z ponad 1700
  serwerów Unix’a (Solarisa i Linuxa) rozmieszczonych na całym globie.

#### Aplikacje Webowe

* [Basecamp][9], aplikacja wspomagająca zarządzanie projektem wydana
  przez [37signals][10], została zaprogramowana w całości w Rubim (Ruby
  on Rails)

* [A List Apart][11], magazyn dla projektantów stron internetowych,
  istniejący juz od 1997, ostatnio został odświeżony i oparty o
  aplikację napisaną w Ruby on Rails.

* [Wyszukiwarka mieszkaniowa Hogo.pl][13] – wyszukiwarka kontekstowa
  ogłoszeń mieszkaniowych. Umożliwia przeszukiwanie wszystkich większych
  serwisów z ogłoszeniami nieruchomości z poziomu jednego serwisu.
  Dynamika i rozszerzalność Rubiego umożliwiła stworzenie systemu, który
  w bardzo przejrzysty i szybki sposób można wzbogacać o zaawansowane
  funkcje wyszukiwarki kontekstowej. Interfejs aplikacji napisany w
  całości w Ruby on Rails natomiast część odpowiedzialna za gromadzenie
  i klasyfikację danych napisana w całości w Rubim z wykorzystaniem
  popularnych bibliotek open-source.

* [Aplikacja do fakturowania Infakt.pl][14] umożliwia wystawianie faktur
  (drukowanie, wysyłanie), tworzenie bazy klientów, wysyłanie upomnień o
  zaległych płatnościach faktur, jak również podziękowania za ich
  opłacenie. Infakt.pl przede wszystkim oszczędza czas użytkowników
  dzięki zautomatyzowaniu wszystkiego, co w wystawianiu faktur
  powtarzalne. Aplikacja została napisana w Ruby on Rails, ponieważ
  pozwoliło to na wydajniejsze prace programistów, szybsze stworzenie
  pierwszej wersji oraz z powodu wbudowanego systemu testów. Sam Ruby
  używany jest do generowania PDF-ów z fakturami oraz systemu
  backupowania.



[1]: http://www.larc.nasa.gov/
[2]: http://www-106.ibm.com/developerworks/linux/library/l-oslab/
[3]: http://www.motorola.com
[4]: https://www.uhn.ca/TorontoRehab
[8]: http://www.level3.com/
[9]: http://www.basecamphq.com
[10]: http://www.37signals.com
[11]: http://www.alistapart.com
[12]: http://www.hogo.pl
[13]: http://www.infakt.pl
