---
layout: news_post
title: "Wydano Ruby 1.9.2-p330"
author: "zzak and hone"
translator: "crabonature"
date: 2014-08-19 01:38:12 +0000
lang: pl
---

Właśnie wydaliśmy 1.9.2-p330, finalne wydanie serii 1.9.2.

Wkrótce po ogłoszeniu
[Końca życia dla 1.9.2 (i 1.8.7)](https://www.ruby-lang.org/pl/news/2014/07/01/eol-for-1-8-7-and-1-9-2/),
została znaleziona krytyczna regresja bezpieczeństwa w 1.9.2.
Tej podatności został przypisany identyfikator [CVE-2014-6438].

Ten błąd występuje podczas parsowania długiego napisu podczas używania metody
URI `decode_www_form_component`. Można to odtworzyć poprzez uruchomienie
poniższego na podatnych wersjach Rubiego:

{% highlight ruby %}
ruby -v -ruri -e'URI.decode_www_form_component "A string that causes catastrophic backtracking as it gets longer %"'
{% endhighlight %}

Z racji tego, że zostało to znalezione i poprawione tuż przed wydaniem 1.9.3,
wersje Rubiego 1.9.3-p0 i późniejsze _nie_ są podatne; jakkolwiek wersje
Rubiego 1.9.2 starsze od 1.9.2-p330 _są_ podatne.

Możesz przeczytać oryginalny raport o błędzie:
<https://bugs.ruby-lang.org/issues/5149#note-4>

## Pobieranie

* <https://cache.ruby-lang.org/pub/ruby/1.9/ruby-1.9.2-p330.tar.bz2>

      SIZE:   9081661 bytes
      MD5:    8ba4aaf707023e76f80fc8f455c99858
      SHA256: 6d3487ea8a86ad0fa78a8535078ff3c7a91ca9f99eff0a6a08e66c6e6bf2040f

* <https://cache.ruby-lang.org/pub/ruby/1.9/ruby-1.9.2-p330.tar.gz>

      SIZE:   11416473 bytes
      MD5:    4b9330730491f96b402adc4a561e859a
      SHA256: 23ef45fdaecc5d6c7b4e9e2d51b23817fc6aa8225a20f123f7fa98760e8b5ca9

* <https://cache.ruby-lang.org/pub/ruby/1.9/ruby-1.9.2-p330.zip>

      SIZE:   12732739 bytes
      MD5:    42d261b28d1b7e500dd3bdbdbfba7fa5
      SHA256: 7a04a028564de7f2ad09f26c8d57fd40fe2b0a6a0e1d9ff7205010ca6e70cea6

Zalecamy zaktualizowanie do stabilnej i wspieranej
[wersji Rubiego](https://www.ruby-lang.org/pl/downloads/).

[CVE-2014-6438]: https://www.cve.org/CVERecord?id=CVE-2014-6438
