---
layout: news_post
title: O snap oficial do Ruby está disponível
author: Hiroshi SHIBATA
translator: "vnbrs (Vinicius Brasil)"
date: 2018-11-08 14:58:28 +0000
lang: pt
---

Nós oficialmente lançamos um pacote snap para a linguagem Ruby.

<https://snapcraft.io/ruby>

Snap é um sistema de pacotes desenvolvido pela Canonical. Ele permite que você
distribua um software com suas dependências para diferentes sistemas Linux.
Isso resolve o problema de quando um usuário não consegue instalar a última
versão do Ruby do repositório padrão de seu sistema, como no  `rpm` or `apt`.

No Ubuntu 16.04 ou superior, você pode instalar o snap do Ruby com o seguinte
comando:

```
sudo snap install ruby --classic
```

(Se você utiliza outras distribuições Linux, por favor acesse
<https://docs.snapcraft.io/installing-snapd/6735>.)

Nosso snap utiliza a funcionalidade de "canal" para distribuir
múltiplas versões de Ruby concorrentemente. Por exemplo, sem especificar
um canal, atualmente a versão 2.5.3 do Ruby será instalada. Mas se você
quer utilizar a versão 2.4, especifique o canal 2.4 como abaixo:

```
sudo snap install ruby --classic --channel=2.4/stable
```

Você pode também utilizar diversos canais. O seguinte comando muda para a versão 2.3:

```
sudo snap switch ruby --channel=2.3/stable
sudo snap refresh
```

Nosso snap configura as variáveis de ambiente `GEM_HOME` e `GEM_PATH`
para `$HOME/.gem`.
Então se você quer executar comandos instalados por gems, como `rails` e
`rspec`, sem utilizar `bundle exec`, você precisará adicionar a seguinte
linha no seu arquivo shell rc (como `.bashrc`):

```
eval `ruby.env`
```

Já que `$HOME/.gem` é compartilhado entre múltiplas versões, se você
troca de versão e as utiliza, você precisará recompilar as extensões C
utilizando o comando `gem pristine --extensions`.

A versão inicial do snap oficial do Ruby foi lançada durante o Snapcraft
summit sediado no escritório da Canonical em Londres entre 6 e 8 de Novembro
de 2018.
Qualquer feedback é bem vindo em <https://github.com/ruby/snap.ruby>.

Aproveite!
