---
layout: page
title: "Belgeler"
lang: tr
---

Bu bölümde Ruby öğrenmenizi kolaylaştıracak el kitapları, kılavuzlar,
referanslar ve diğer belgeleri bulacaksınız.
{: .summary}

### Ruby'yi Kurma

[Ruby'yi tarayıcınızda kolayca deneyebilecek olsanız da][1], Ruby'yi kurmak
isterseniz, [kurulum kılavuzu](installation/)nu okuyabilirsiniz.

### Başlangıç

[Resmi SSS](/en/documentation/faq/)
: Resmi sık sorulan sorular.

[2014 Akademik Bilişim Konferansı Ruby Eğitimi Notları][ab2014-ruby-notlari] (Türkçe)
: Sıtkı Bağdat'ın 2014 yılındaki Akademik Bilişim Konferansı'nda düzenlediği
  Ruby eğitimindeki notların Leyla Kapı tarafından düzenlenmiş hali.

[Ruby Koans][2]
: Koans Ruby öğrenmek için bir aydınlanma yolu üzerinden yürümenizi
  sağlar. Amaç Ruby dilini, deyimlerini, yapısını ve birkaç çok
  kullanılan yapılarını öğrenmek ama bununla beraber size kültürünü de
  öğretiyor.

[Why’s (Poignant) Guide to Ruby][5]
: Ruby’nin hikayelerle, nüktelerle ve karikatürlerle anlatıldığı
  sıradışı ama ilginç bir kitap. Orjinali *why the lucky stiff*
  tarafından yazılmıştır, bu kılavuz Ruby’ye yeni başlayanlar için bir
  klasiktir.

[Ruby Essentials][7]
: Ruby Essentials, Ruby öğrenmek için öz ve takip etmesi kolay şekilde
  tasarlanan ücretsiz bir çevrimiçi kitaptır.

[Learn to Program][8]
: Chris Pine tarafından, yeni başlayanlar için yazılmış harika bir
  kılavuz. Eğer programlama bilmiyorsanız, buradan başlayın.

[Learn Ruby the Hard Way][38]
: Ruby'nin en temelinden başlayarak nesne yönelimli programlama ve web
  geliştirmeye kadar size kılavuzluk edecek açıklamalı alıştırmaların çok iyi
  bir bütünüdür.

### El Kitapları

[Ruby 101 Kitabı][ruby-101-kitabi] (Türkçe)
: Uğur Özyılmazel tarafından yazılan hem temel hem de ileri düzey konuları
  kapsayan bir kitapçık.

[Programming Ruby][9]
: [Pragmatic Programmers’ın kitabı][10]‘nın ilk baskısı. İngilizce Ruby
  kaynakları arasında hatırı sayılır bir yere sahip olan bu kitabı,
  çevrimiçi okuyabilirsiniz.

[Ruby Programming Vikikitabı][12]
: Başlangıç ve ileri düzeyde içeriğe sahip olan çevrimiçi, tam bir dil
  başvurusu da sunan bir kitapçık.

### Referans Belgeleri

[Resmi API Belgelendirmesi][docs-rlo-en]
: Şu anki yayınlanmamış (trunk) sürümü de içeren farklı sürümlerin resmi API
  belgelendirmesi.

[Ruby Çekirdek Referansı][13]
: [RDoc][14] ile kaynak kodundan üretilmiş bir belge. Bu belge tüm
  çekirdek sınıfları ve modülleri (String, Array, Symbol gibi) içerir.

[Ruby Standart Kütüphane Referansı][15]
: Yine RDoc ile üretilmiş bu referans belgesi, standart kütüphaneyi
  kapsayacak niteliktedir.

[Ruby C API Başvurusu][extensions]
: Ruby'nin C API'ına resmi bir giriştir.
  Eğer C uzantıları yazmak ya da Ruby'nin geliştirilmesine katkıda bulunmak
  istiyorsanız, mükemmeldir.

[RubyDoc.info][16]
: Ruby gem’leri ve GitHub’daki Ruby projelerinin başvuru belgelendirmeleri için
  tek site.

[Ruby & Rails Aranabilir API Belgeleri][17]
: Akıllı arama özellikleri olan Rails ve Ruby belgelendirmesi.

[APIdock][18]
: Kullanıcı notları ile Ruby, Rails ve RSpec belgelendirmesi.

[RubyAPI.org][rubyapi-org]
: Ruby sınıflarını, modüllerini ve metodlarını kolayca bulun ve gözden geçirin.

### Editörler ve IDE'ler

Ruby'de kodlama için işletim sisteminizin varsayılan editörünü
kullanabilirsiniz. Fakat kodlamada daha etkili olmak için temel Ruby
desteğine (sözdizimi vurgulaması, dosya tarama) sahip bir kaynak kod editörü
veya gelişmiş özelliklere (kod tamamlama, refactoring, test desteği) sahip
bir tümleşik geliştirme ortamı seçmeniz daha iyi olur.

İşte Rubyciler tarafından kullanılan gözde araçların bir listesi:

* Linux ve platformlararası araçlar:
  * [Aptana Studio][19]
  * [Emacs][20], [Ruby modu][21] ve [Rsense][22] ile
  * [Geany][23]
  * [gedit][24]
  * [Vim][25], [vim-ruby][26] eklentisi ve [Rsense][22] ile
  * [RubyMine][27]
  * [SciTe][28]
  * [NetBeans][36]
  * [Sublime Text][37]
  * [Atom][atom]
  * [Visual Studio Code][vscode]

* Windows'ta:
  * [Notepad++][29]

* macOS'ta:
  * [TextMate][32]
  * [BBEdit][33]
  * [Dash][39] (belgelendirme tarayıcısı)

### Diğer Belgeler

[Ruby-doc.org][34] Ruby hakkındaki İngilizce belgeleri bir araya
toplamayı amaçlayan bir site. Ruby hakkında aklınıza takılan herhangi bir soru
için [e-posta listeleri](/tr/community/mailing-lists/) iyi bir başlangıç
olacaktır.



[1]: https://try.ruby-lang.org/
[2]: https://rubykoans.com/
[5]: https://poignant.guide
[7]: http://www.techotopia.com/index.php/Ruby_Essentials
[8]: http://pine.fm/LearnToProgram/
[9]: http://www.ruby-doc.org/docs/ProgrammingRuby/
[10]: http://pragmaticprogrammer.com/titles/ruby/index.html
[12]: http://en.wikibooks.org/wiki/Ruby_programming_language
[13]: http://www.ruby-doc.org/core
[14]: https://ruby.github.io/rdoc/
[15]: http://www.ruby-doc.org/stdlib
[extensions]: https://docs.ruby-lang.org/en/master/extension_rdoc.html
[16]: http://www.rubydoc.info/
[17]: http://rubydocs.org/
[18]: http://apidock.com/
[rubyapi-org]: https://rubyapi.org/
[19]: http://www.aptana.com/
[20]: http://www.gnu.org/software/emacs/
[21]: http://www.emacswiki.org/emacs/RubyMode
[22]: http://rsense.github.io/
[23]: http://www.geany.org/
[24]: http://projects.gnome.org/gedit/screenshots.html
[25]: http://www.vim.org/
[26]: https://github.com/vim-ruby/vim-ruby
[27]: http://www.jetbrains.com/ruby/
[28]: http://www.scintilla.org/SciTE.html
[29]: http://notepad-plus-plus.org/
[32]: http://macromates.com/
[33]: https://www.barebones.com/products/bbedit/
[34]: http://ruby-doc.org
[36]: https://netbeans.org/
[37]: http://www.sublimetext.com/
[38]: https://learncodethehardway.org/ruby/
[39]: http://kapeli.com/dash
[docs-rlo-en]: https://docs.ruby-lang.org/en/
[atom]: https://atom.io/
[vscode]: https://code.visualstudio.com/
[ruby-101-kitabi]: https://vigo.github.io/ruby101-kitap/
[ab2014-ruby-notlari]: https://github.com/leylaKapi/AB2014-Ruby-Programlama-Dili/blob/master/Ruby_AB2014.md
