---
layout: page
title: "Tài liệu"
lang: vi
---

Bạn sẽ tìm được các nguồn tài liệu hướng dẫn và tham khảo liên quan đến Ruby
tại đây.
{: .summary}

### Cài đặt Ruby

Trừ khi bạn chỉ muốn thử Ruby trên trình duyệt (xem những liên kết bên dưới),
bạn cần có Ruby được cài đặt trong máy tính của bạn. Bạn có thể kiểm tra liệu
Ruby đã có sẵn hay chưa bằng việc mở terminal lên và gõ

{% highlight sh %}
ruby -v
{% endhighlight %}

Câu lệnh này nên in ra một số về phiên bản của Ruby đã được cài đặt. Nếu không
thấy, hãy xem [trang cài đặt](installation/) để có những tùy chọn khác nhau cho
việc cài đặt Ruby.

### Khởi đầu

[Thử Ruby!][1]
: Một bài hướng dẫn tương tác cho phép bạn dùng thử Ruby thực sự trên trình
  duyệt. 15 phút của bài hướng dẫn này dành cho những người mới bắt đầu và
  muốn có cảm nhận về Ruby.

[Ruby Koans][2]
: Koans sẽ khai sáng con đường của bạn đến với Ruby. Chúng tôi sẽ hướng dẫn
  bạn kiến thức về ngôn ngữ, cú pháp, cấu trúc và một số hàm và thư viện phổ
  dụng của Ruby.

[Why’s (Poignant) Guide to Ruby][5]
: Một cuốn sách thú vị và độc đáo, dạy bạn Ruby qua các mẩu truyện tranh vui
  nhộn. Ban đầu được tạo ra bởi *why the lucky stiff*. Sách này được xem là
  kinh điển cho người nhập môn Ruby.

[Tìm hiểu Ruby trong 25 phút](/vi/documentation/quickstart/)
: Một hướng dẫn hay được viết lại từ Ruby căn bản. Bạn không cần bỏ quá 25
  phút cho phần này.

[Đến với Ruby từ ngôn ngữ khác](/vi/documentation/ruby-from-other-languages/)
: Bạn đến với Ruby từ ngôn ngữ khác? Bất kể nó là C, C++, Java,
  Perl, PHP hay Python, bài viết này sẽ giải quyết cho bạn.

[Ruby Essentials][7]
: Ruby Essentials là một cuốn sách trực tuyến miễn phí hướng dẫn học Ruby dễ
  dàng và ngắn gọn.

[Học cách lập trình][8]
: Một bài hướng dẫn nhỏ tuyệt vời cho lập trình viên mới viết bởi Chris Pine.
  Nếu bạn không biết phải viết chương trình như thế nào, hãy bắt đầu từ đây.

[Bài học Ruby đắt giá][38]
: Một bộ bài tập rất hay với những giải thích có thể hướng dẫn bạn từ những
  điều cơ bản nhất của Ruby cho tới lập trình hướng đối tượng và lập trình web.

### Hướng dẫn sử dụng

[Lập trình Ruby][9]
: Hội thảo làm việc trên Ruby bằng Tiếng Anh, phiên bản đầu tiên
  [Sách của Lập trình viên thực dụng][10] hiện đang được miễn phí trực tuyến.

[Sách bách khoa lập trình Ruby][12]
: Một hướng dẫn trực tuyến miễn phí với người mới bắt đầu và nội dung trung
  cấp cộng với một tài liệu tham khảo ngôn ngữ chi tiết.

### Tài liệu tham khảo

[Tài liệu tham khảo lõi Ruby][13]
: Tải thẳng từ mã nguồn sử dụng [RDoc][14], thư viện này bao gồm các bài viết
  về các lớp lõi và mô đun (ví dụ Xâu, Mảng, Ký tự, vv).

[Thư viện tài liệu tham khảo Ruby chuẩn][15]
: Cũng được tải từ mã nguồn sử dụng RDoc, đưa ra tài liệu của thư viện chuẩn.

[Tài liệu tham khảo Ruby C API][extensions]
: Sự giới thiệu chính thức về Ruby's C API. Tuyệt vời nếu bạn muốn
  viết những mở rộng của C hoặc đóng góp cho sự phát triển của Ruby.

[RubyDoc.info][16]
: Các trang web một cửa cho tài liệu tham khảo về Ruby gems và GitHub chứa các
  dự án Ruby.

[Ruby & Rails Searchable API Docs][17]
: Tài liệu Rails và Ruby với tìm kiếm thông minh.

[APIdock][18]
: Tài liệu Ruby, Rails và RSpec với các ghi chú của người sử dụng.

### Phần mềm chỉnh sửa và các môi trường phát triển tích hợp

Để lập trình trong Ruby bạn có thể sử dụng chương trình chỉnh sửa mặc định của
hệ điều hành. Nhân tiện, để hiệu quả hơn trong việc lập trình, tốt hơn bạn nên
chọn một chương trình chỉnh sửa mã nguồn có hỗ trợ Ruby căn bản (ví dụ đánh
dấu cú pháp, lựa chọn tài liệu) hoặc môi trường lập trình tích hợp với các
tính năng nâng cao (ví dụ: tự động hoàn thiện, tái cấu trúc, hỗ trợ kiểm tra).

Đây là danh sách các công cụ phổ biến thường được dùng:

* Linux và công cụ đa nền tảng:
  * [Aptana Studio][19]
  * [Emacs][20] with [Ruby mode][21] and [Rsense][22]
  * [Geany][23]
  * [gedit][24]
  * [Vim][25] with [vim-ruby][26] plugin and [Rsense][22]
  * [RubyMine][27]
  * [SciTe][28]
  * [NetBeans][36]
  * [Sublime Text][37]
  * [Atom][atom]
  * [Visual Studio Code][vscode]

* Trên Windows:
  * [Notepad++][29]

* Trên macOS:
  * [TextMate][32]
  * [BBEdit][33]
  * [Dash][39] (trình duyệt tài liệu)

### Đọc thêm

[Ruby-Doc.org][34] duy trì một danh sách đầy đủ của nguồn tài liệu tiếng anh.
Nếu bạn có câu hỏi gì về Ruby, [danh sách mail](/vi/community/mailing-lists/)
là một nơi tuyệt vời.



[1]: https://try.ruby-lang.org/
[2]: https://rubykoans.com/
[5]: https://poignant.guide
[7]: http://www.techotopia.com/index.php/Ruby_Essentials
[8]: http://pine.fm/LearnToProgram/
[9]: http://www.ruby-doc.org/docs/ProgrammingRuby/
[10]: http://pragmaticprogrammer.com/titles/ruby/index.html
[12]: http://en.wikibooks.org/wiki/Ruby_programming_language
[13]: http://www.ruby-doc.org/core
[14]: https://ruby.github.io/rdoc/
[15]: http://www.ruby-doc.org/stdlib
[extensions]: https://docs.ruby-lang.org/en/master/extension_rdoc.html
[16]: http://www.rubydoc.info/
[17]: http://rubydocs.org/
[18]: http://apidock.com/
[19]: http://www.aptana.com/
[20]: http://www.gnu.org/software/emacs/
[21]: http://www.emacswiki.org/emacs/RubyMode
[22]: http://rsense.github.io/
[23]: http://www.geany.org/
[24]: http://projects.gnome.org/gedit/screenshots.html
[25]: http://www.vim.org/
[26]: https://github.com/vim-ruby/vim-ruby
[27]: http://www.jetbrains.com/ruby/
[28]: http://www.scintilla.org/SciTE.html
[29]: http://notepad-plus-plus.org/
[32]: http://macromates.com/
[33]: https://www.barebones.com/products/bbedit/
[34]: http://ruby-doc.org
[36]: https://netbeans.org/
[37]: http://www.sublimetext.com/
[38]: https://learncodethehardway.org/ruby/
[39]: http://kapeli.com/dash
[atom]: https://atom.io/
[vscode]: https://code.visualstudio.com/
