---
layout: news_post
title: "Heap-Überlauf beim Parsen von URI-Escape-Sequenzen in YAML (CVE-2014-2525)"
author: "hone and zzak"
translator: "Marcus Stollsteimer"
date: 2014-03-29 01:49:25 +0000
tags: security
lang: de
---

Beim Parsen von URI-Escape-Sequenzen in YAML kann es in Ruby zu einem Überlauf kommen.
Dieser Sicherheitslücke wurde die CVE-Nummer
[CVE-2014-2525](http://www.ocert.org/advisories/ocert-2014-003.html)
zugewiesen.

## Details

Immer dann, wenn ein YAML-String mit Tags geparst wird, kann ein
speziell angefertigter String einen Heap-Überlauf verursachen,
der möglicherweise zur Ausführung beliebigen Codes führen kann.

Verwundbarer Code sieht zum Beispiel so aus:

{% highlight ruby %}
YAML.load <code_from_unknown_source>
{% endhighlight %}

## Betroffene Versionen

Seit Ruby 1.9.3-p0 wird standardmäßig psych als YAML-Parser verwendet.
Betroffen sind alle Versionen von psych, die gegen libyaml `<= 0.1.5` gelinkt sind.

Die verwendete Version von libyaml kann festgestellt werden mit:

{% highlight sh %}
$ ruby -rpsych -e 'p Psych.libyaml_version'
[0, 1, 5]
{% endhighlight %}

## Lösungen

Nutzer, die libyaml systemweit installiert haben, sollten libyaml auf die
Version `0.1.6` aktualisieren. Beim erneuten Kompilieren von Ruby muss der
Pfad der aktualisierten Version angegeben werden:

{% highlight sh %}
$ ./configure --with-yaml-dir=/path/to/libyaml
{% endhighlight %}

Nutzer ohne eine systemweite Installation von libyaml verwenden die in psych
eingebundene Version. Diesen Nutzern wird empfohlen, psych auf die Version `2.0.5`
zu aktualisieren, die libyaml `0.1.6` ausliefert:

{% highlight sh %}
$ gem install psych
{% endhighlight %}

## Verlauf

* Erstveröffentlichung: 2014-03-29 01:49:25 UTC
* Aktualisiert: 2014-03-29 09:37:00 UTC
