---
layout: page
title: "Success Stories"
lang: en
---

Many people use Ruby in their daily jobs. Others just as a hobby. Here
you’ll find a small sample of real world usage of Ruby.
{: .summary}

#### Simulations

* [NASA Langley Research Center][1] uses Ruby to conduct simulations.

* A research group in [Motorola][2] uses Ruby to script a simulator,
  both to generate scenarios and to post process the data.

#### 3D Modeling

* [Google SketchUp][3] is a 3D modeling application that uses Ruby for
  its macro scripting API.

#### Business

* [Toronto Rehab][4] uses a RubyWebDialogs-based app to manage and track
  on-call and on-site support for the IT help desk and IT operations
  teams.

#### Robotics

* At MORPHA project, Ruby was used to implement the reactive
  control part for the Siemens service robot.

#### Telephony

* Ruby is being used within Lucent on a 3G wireless telephony
  product.

#### System Administration

* Ruby was used to write the central data collection portion of [Level 3
  Communications][8] Unix Capacity and Planning system that gathers
  performance statistics from over 1700 Unix (Solaris and Linux) servers
  scattered around the globe.

#### Web Applications

* [Basecamp][9], a web-based project management application, is programmed entirely in Ruby.

* [A List Apart][10], a magazine for people who make websites that has
  been around since 1997, has recently been revamped and uses a custom
  application built with Ruby on Rails.

#### Security

* The [Metasploit Framework][metasploit], a community open source project
  managed by [Rapid7][rapid7], is a free penetration testing platform that
  helps IT professionals assess the security of their networks and
  applications. The Metasploit Project consists of over 700,000 lines of
  code and has been downloaded over a million times in 2010.
  The commercial editions developed by Rapid7 are also based on Ruby.

* The [Arachni Web Application Security Scanner][arachni] is a free, modular,
  high-performance Ruby framework aimed towards helping penetration testers
  and administrators evaluate the security of modern web applications.



[1]: http://www.larc.nasa.gov/
[2]: http://www.motorola.com
[3]: http://www.sketchup.com/
[4]: https://www.uhn.ca/TorontoRehab
[8]: http://www.level3.com/
[9]: https://www.basecamp.com
[10]: http://www.alistapart.com

[metasploit]: http://www.metasploit.com
[rapid7]: http://www.rapid7.com
[arachni]: http://www.arachni-scanner.com/
