---
layout: news_post
title: "Another DoS Vulnerability in CGI Library"
author: "Shugo Maeda"
lang: en
---

Another vulnerability has been discovered in the CGI library (cgi.rb)
that ships with Ruby which could be used by a malicious user to create a
denial of service attack (DoS).

This vulnerability is open to the public as [JVN#84798830][1].

Please note that the previous patch
([&lt;URL:https://cache.ruby-lang.org/pub/ruby/1.8/ruby-1.8.5-cgi-dos-1.patch&gt;][2])
does not fix this problem.

#### Impact

A specific HTTP request for any web application using cgi.rb causes CPU
consumption on the machine on which the web application is running. Many
such requests result in a denial of service.

#### Vulnerable versions

1.8 series
: 1\.8.5 and all prior versions

Development version (1.9 series)
: All versions before 2006-12-04

#### Solution

1.8 series

: Please upgrade to 1.8.5-p2.

  [&lt;URL:https://cache.ruby-lang.org/pub/ruby/1.8/ruby-1.8.5-p2.tar.gz&gt;][3]
  (4519151 bytes, md5sum: a3517a224716f79b14196adda3e88057)

  Please note that a package that corrects this weakness may already be
  available through your package management software.

Development version (1.9 series)
: Please update your Ruby to a version after 2006-12-04.



[1]: http://jvn.jp/jp/JVN%2384798830/index.html
[2]: https://cache.ruby-lang.org/pub/ruby/1.8/ruby-1.8.5-cgi-dos-1.patch
[3]: https://cache.ruby-lang.org/pub/ruby/1.8/ruby-1.8.5-p2.tar.gz
