---
layout: news_post
title: "CVE-2024-27282: Arbitrary memory address read vulnerability with Regex search"
author: "hsbt"
translator:
date: 2024-04-23 10:00:00 +0000
tags: security
lang: en
---

We have released the Ruby version 3.0.7, 3.1.5, 3.2.4 and 3.3.1 that have a security fix for an arbitrary memory address read vulnerability in Regex search.
This vulnerability has been assigned the CVE identifier [CVE-2024-27282](https://www.cve.org/CVERecord?id=CVE-2024-27282).

## Details

An issue was discovered in Ruby 3.x through 3.3.0.

If attacker-supplied data is provided to the Ruby regex compiler, it is possible to extract arbitrary heap data relative to the start of the text, including pointers and sensitive strings.

## Recommended action

We recommend to update the Ruby to version 3.3.1 or later. In order to ensure compatibility with older Ruby series, you may update as follows instead:

* For Ruby 3.0 users: Update to 3.0.7
* For Ruby 3.1 users: Update to 3.1.5
* For Ruby 3.2 users: Update to 3.2.4
* For Ruby 3.3 users: Update to 3.3.1

## Affected versions

* Ruby 3.0.6 or lower
* Ruby 3.1.4 or lower
* Ruby 3.2.3 or lower
* Ruby 3.3.0

## Credits

Thanks to [sp2ip](https://hackerone.com/sp2ip?type=user) for discovering this issue.

## History

* Originally published at 2024-04-23 10:00:00 (UTC)
