---
layout: news_post
title: "CVE-2020-10933: Vulnerabilidad de exposición del montón (heap) en la librería de zócalos (sockets)"
author: "mame"
translator: "vtamara"
date: 2020-03-31 12:00:00 +0000
tags: security
lang: es
---

Una vulnerabilidad de exposición del montón (heap) ha sido descubierta en
la librería de zócalos (sockets).
A esta vulnerabilidad se le ha asignado el identificador
CVE [CVE-2020-10933](http://cve.mitre.org/cgi-bin/cvename.cgi?name=CVE-2020-10933).
Recomendamos con énfasis actualizar Ruby.

## Detalles

Cuando se llama `BasicSocket#recv_nonblock` y `BasicSocket#read_nonblock` con
argumentos de tamaño y colchón (buffer), estas funciones inicialmente cambian
el tamaño del colchon al tamaño especificado.  En casos donde la operación
fuera a bloquearse, retornan sin copiar dato alguno.  Asi que, la
cadena colchón incluirá datos arbitrarios del montón (heap). Esto podría
exponer datos sensibles del interprete.

Este problema puede explotarse sólo en Linux. El problema ha estado
presente desde Ruby 2.5.0; la serie 2.4 no es vulnerable.

## Versiones afectadas

* Serie Ruby 2.5: 2.5.7 y anteriores
* Serire Ruby 2.6: 2.6.5 y anteriores
* Serire Ruby 2.7: 2.7.0
* en la rama master versiones anteriores a 61b7f86248bd121be2e83768be71ef289e8e5b90

## Créditos

Agradecemos a Samuel Williams por descubrir este problema.

## Historia

* Publicado originalmente el 2020-03-31 12:00:00 (UTC)
