---
layout: page
title: "Kisah Sukses"
lang: id
---

Banyak yang telah menggunakan Ruby dalam pekerjaan sehari-hari. Ada juga
yang menggunakannya sebagai hobi. Di sini Anda akan menemukan sebagian
kecil contoh dari berbagai penggunaan Ruby di dunia nyata.
{: .summary}

#### Simulasi

* [NASA Langley Research Center][1] menggunakan Ruby untuk melakukan
  simulasi.

* Sebuah kelompok riset di [Motorola][2] menggunakan Ruby untuk melakukan
  simulasi, baik untuk meng-*generate* skenario maupun memproses data
  hasilnya.

#### Pemodelan 3D

* [Google SketchUp][3] adalah sebuah aplikasi pemodelan 3D yang menggunakan
  Ruby untuk *macro scripting API*.

#### Bisnis

* [Toronto Rehab][4] menggunakan aplikasi berbasis RubyWebDialogs dalam
  manajemen dukungan *on-call* dan *on-site* untuk *help desk* Teknologi
  Informasi dan tim operasi Teknologi Informasi.

#### Robotika

* Proyek MORPHA menggunakan Ruby untuk mengimplementasikan bagian
  pengendali reaktif dari robot Siemens yang digunakan.

#### Telekomunikasi

* Ruby digunakan oleh Lucent pada produk wireless 3G yang mereka
  kembangkan.

#### Administrasi Sistem

* Ruby digunakan untuk mengembangkan koleksi data sentral di [Level 3
  Communications][8] pada sistem *Unix Capacity and Planning* yang
  memproses statistik di lebih dari 1700 server Unix (Solaris dan Linux)
  yang tersebar di seluruh dunia.

#### Aplikasi Web

* [Basecamp][9], sebuah aplikasi manajemen proyek berbasis *web* yang
  dikembangkan oleh [37signals][10], diprogram sepenuhnya dalam bahasa Ruby.

* [A List Apart][11], sebuah majalah digital bagi para *webmaster* yang telah
  berdiri sejak tahun 1997, telah direnovasi dan menggunakan aplikasi
  khusus yang dikembangkan menggunakan Ruby on Rails.

#### Keamanan

* [Metasploit Framework][metasploit], sebuah komunitas proyek *open source*
  yang dikelola oleh [Rapid7][rapid7], sebuah *platform penetration testing*
  gratis yang membantu IT *proffessional* untuk menilai keamanan dari
  jaringan dan aplikasi mereka. Metasploit Project terdiri dari lebih
  700000 baris kode dan telah diunduh lebih dari jutaan kali pada tahun 2010.
  Edisi komersial dikembangkan oleh Rapid7 juga berbasis Ruby.

* [Arachni Web Application Security Scanner][arachni] adalah sebuah Ruby
  *framework* yang gratis, modular, dan *high-performance* yang ditujukan
  untuk membantu *penetration tester* dan administrator mengevaluasi
  keamanan dari aplikasi *web* modern.



[1]: http://www.larc.nasa.gov/
[2]: http://www.motorola.com
[3]: http://www.sketchup.com/
[4]: https://www.uhn.ca/TorontoRehab
[8]: http://www.level3.com/
[9]: http://www.basecamphq.com
[10]: http://www.37signals.com
[11]: http://www.alistapart.com
[metasploit]: http://www.metasploit.com
[rapid7]: http://www.rapid7.com
[arachni]: http://www.arachni-scanner.com/
