---
layout: news_post
title: "Kerentanan Hilangnya $SAFE terkait Exception#to_s / NameError#to_s (CVE-2012-4464, CVE-2012-4466)"
author: "usa"
translator: "catcyborg"
lang: id
---

Beberapa kerentanan ditemukan pada Exception#to\_s, NameError#to\_s, dan
name\_err\_mesg\_to\_s() yang merupakan API internal interpreter Ruby.
Kode pengguna jahat dapat mem-bypass cek $SAFE dengan menggunakan salah satu
dari beberapa kelemahan keamanan tersebut.

## Rincian

Mekanisme $SAFE Ruby memungkinkan kode pengguna yang tak terpercaya
untuk berjalan dalam mode $SAFE &gt;= 4. Ini adalah sejenis sandbox,
jadi beberapa operasi dibatasi dalam mode itu untuk melindungi data lain
di luar sandbox.

Masalahnya ditemukan di sekitar mekanisme ini. API internal interpreter
Exception#to\_s, NameError#to\_s, dan name\_err\_mesg\_to\_s() tidak
menangani dengan benar bit $SAFE, jadi sebuah object String yang tidak
di-taint dapat ditandai secara destruktif sebagai di-taint dengan menggunakan
method-method itu. Dengan itu, kode tak terpercaya di sebuah sandbox dapat
mengubah string yang tadinya tidak di-taint secara destruktif.

Ruby 1.8 pernah mengalami [masalah keamanan yang mirip][1] sekali. Itu telah
memperbaiki Exception#to\_s dan NameError#to\_s, tetapi masalah
name\_err\_mesg\_to\_str() masih ada pada perbaikan keamanan sebelumnya.

## Versi yang Terkena Dampak

* semua Ruby 1.8.7 sebelum patchlevel 371
* semua Ruby 1.9.3 sebelum patchlevel 286
* semua branch development Ruby 2.0 sebelum revisi r37068

## Solusi

Harap upgrade ke versi terbaru.

## Ucapan Terima Kasih

Kerentanan ini ditemukan oleh Tyler Hickes.

## Update

* Awalnya diterbitkan pada tanggal 2012-10-12 19:17:50 JST.



[1]: {{ site.url }}/en/news/2011/02/18/exception-methods-can-bypass-safe/
