---
layout: news_post
title: "CVE-2018-16396: Penanda tercemar tidak disebarkan ke Array#pack dan String#unpack dengan beberapa arahan"
author: "usa"
translator: "meisyal"
date: 2018-10-17 14:00:00 +0000
tags: security
lang: id
---

Di `Array#pack` dan `String#unpack` dengan beberapa format, penanda tercemar
dari data asli tidak disebarkan ke *string/array* yang dikembalikan.
Kerentanan ini telah ditetapkan sebagai penanda CVE [CVE-2018-16396](http://cve.mitre.org/cgi-bin/cvename.cgi?name=CVE-2018-16396).

## Detail

`Array#pack` *method* mengubah isi penerima ke dalam sebuah *string* dalam
format tertentu. Jika penerima berisi beberapa objek tercemar, *string* yang
dikembalikan juga seharusnya tercemar. `String#unpack` *method* yang mengubah
penerima menjadi sebuah *array* seharusnya juga menyebarkan penanda yang
tercemar tersebut ke objek yang berisi *array* yang dikembalikan. Tetapi,
dengan arahan `B`, `b`, `H`, dan `h`, penanda tercemar tidak tersebar.
Sehingga, jika sebuah skrip memproses masukan yang tidak dapat dipercaya
melalui `Array#pack` dan/atau `String#unpack` dengan arahan-arahan tersebut
dan mengecek kepercayaan dengan penanda tercemar, pengecekan bisa jadi salah.

Semua pengguna yang terimbas dengan rilis ini seharusnya memperbarui segera.

## Versi Terimbas

* Rangkaian Ruby 2.3: 2.3.7 dan sebelumnya
* Rangkaian Ruby 2.4: 2.4.4 dan sebelumnya
* Rangkaian Ruby 2.5: 2.5.1 dan sebelumnya
* Rangkaian Ruby 2.6: 2.6.0-preview2 dan sebelumnya
* sebelum revisi *trunk* r65125

## Rujukan

Terima kasih kepada [Chris Seaton](https://hackerone.com/chrisseaton) yang telah melaporkan masalah ini.

## Riwayat

* Semula dipublikasikan pada 2018-10-17 14:00:00 (UTC)
