---
layout: news_post
title: "CVE-2021-28966: Path traversal pada Tempfile di Windows"
author: "mame"
translator: "meisyal"
date: 2021-04-05 12:00:00 +0000
tags: security
lang: id
---

Ada sebuah keretanan pembuatan direktori secara tidak sengaja pada pustaka
*tmpdir* yang di-*bundle* dengan Ruby di Windows. Selain itu, ada juga
kerentanan pembuatan berkas secara tidak sengaja pada pustaka *tempfile* yang
di-*bundle* dengan Ruby di Windows. Kerentanan ini telah ditetapkan sebagai
penanda [CVE-2021-28966](https://cve.mitre.org/cgi-bin/cvename.cgi?name=CVE-2021-28966).

## Detail

*Method* `Dir.mktmpdir` yang dikenalkan oleh pustaka *tmpdir* menerima prefiks
dan sufiks dari direktori yang akan dibuat pada parameter pertama. Prefiks dapat
berisi penentu direktori relatif `"..\\"`, sehingga *method* ini dapat
digunakan untuk mengarahkan ke direktori manapun. Jika sebuah *script* menerima
masukan dari luar sebagai prefiks dan sasaran direktori tidak memiliki izin
semestinya atau Ruby tidak memiliki hak akses, penyerang dapat membuat
sebuah direktori atau berkas pada direktori manapun.

Ini adalah isu yang sama pada [CVE-2018-6914](https://www.ruby-lang.org/id/news/2018/03/28/unintentional-file-and-directory-creation-with-directory-traversal-cve-2018-6914/), tetapi perbaikan
sebelumnya belum mencakup Windows.

Semua pengguna yang terimbas dengan rilis seharusnya memperbarui segera.

## Versi terimbas

* Ruby 2.7.2 atau sebelumnya
* Ruby 3.0.0

## Rujukan

Terima kasih kepada [Bugdiscloseguys](https://hackerone.com/bugdiscloseguys)
yang telah menemukan isu ini.

## Riwayat

* Semula dipublikasikan pada 2021-04-05 12:00:00 (UTC)
