---
layout: page
title: "Keamanan"
lang: id
---

Di sini Anda akan menemukan informasi terkait isu-isu keamanan dari Ruby.
{: .summary}

## Melaporkan Kerentanan Keamanan

Kerentanan keamanan pada bahasa pemrograman Ruby harus
dilaporkan melalui
[halaman bounty program di HackerOne](https://hackerone.com/ruby).
Mohon pastikan Anda membaca detail seputar ruang lingkup dari
program ini sebelum melaporkan sebuah isu. Laporan yang valid
akan dipublikasikan setelah perbaikan dilakukan.

Jika Anda menemukan sebuah isu yang berdampak pada salah satu laman kami, mohon
laporkan [melalui GitHub](https://github.com/ruby/www.ruby-lang.org/issues/new)
atau Anda dapat mengecek [Google Groups](https://groups.google.com/g/ruby-security-ann)
untuk pemberitahuan.

Jika Anda menemukan sebuah isu pada Ruby *gem* tertentu, ikuti
[instruksi pada RubyGems.org](http://guides.rubygems.org/security/#reporting-security-vulnerabilities).

Agar terhubung dengan tim keamanan secara langsung di luar
HackerOne, Anda dapat mengirim surel ke security@ruby-lang.org
([PGP public key](/security.asc)), yang merupakan sebuah *mailing list* pribadi.

Anggota dari *mailing list* tersebut adalah orang-orang yang merawat Ruby
(Ruby *committer* dan *author* dari implementasi Ruby lainnya,
distributor, dan PaaS *platformer*).
Anggota harus seorang individu, *mailing list* tidak diizinkan.

## Isu-isu yang diketahui

_Lihat [halaman bahasa Inggris](/en/security/) untuk daftar
kerentanan keamanan yang lengkap dan terbaru.
Daftar berikut hanya berisi pemberitahuan yang telah diterjemahkan,
mungkin tidak lengkap atau usang._

Berikut adalah isu-isu terkini:

{% include security_posts.html %}

dan isu lainnya:

* [Kerentanan DoS Ekspansi Entity pada REXML (Bom XML, CVE-2013-1821)][1]
  dipublikasikan pada 22 Februari 2013.
* [Denial of Service dan Kerentanan Penciptaan Unsafe Object pada JSON
  (CVE-2013-0269)][2] dipublikasikan pada 22 Februari 2013.
* [XSS exploit of RDoc documentation generated by rdoc
  (CVE-2013-0256)][3] dipublikasikan pada 6 Februari 2013.
* [Kerentanan DoS Hash-flooding untuk Ruby 1.9 (CVE-2012-5371)][4]
  dipublikasikan pada 10 November 2012.
* [Pembuatan File Tak Sengaja yang Disebabkan Memasukkan Karakter NUL Ilegal
  (CVE-2012-4522)][5] dipublikasikan pada 12 Oktober 2012.
* [$SAFE escaping vulnerability about Exception#to\_s / NameError#to\_s
  (CVE-2012-4464, CVE-2012-4466)][6] dipublikasikan pada 12 Oktober 2012.
* [Security Fix for RubyGems: SSL server verification failure for remote
  repository][7] dipublikasikan pada 20 April 2012.
* [Security Fix for Ruby OpenSSL module: Allow 0/n splitting as a
  prevention for the TLS BEAST attack][8] dipublikasikan pada 16 Februari 2012.
* [Serangan Denial of Service Ditemukan pada Algoritma Hash Ruby
  (CVE-2011-4815)][9] dipublikasikan pada 28 Desember 2011.

Untuk isu-isu sebelumnya lihat [halaman bahasa Inggris][10].


[1]: /id/news/2013/02/22/rexml-dos-2013-02-22/
[2]: /id/news/2013/02/22/json-dos-cve-2013-0269/
[3]: /id/news/2013/02/06/rdoc-xss-cve-2013-0256/
[4]: /id/news/2012/11/09/ruby19-hashdos-cve-2012-5371/
[5]: /id/news/2012/10/12/poisoned-NUL-byte-vulnerability/
[6]: /id/news/2012/10/12/cve-2012-4464-cve-2012-4466/
[7]: /id/news/2012/04/20/ruby-1-9-3-p194-is-released/
[8]: /id/news/2012/02/16/security-fix-for-ruby-openssl-module/
[9]: /id/news/2011/12/28/denial-of-service-attack-was-found-for-rubys-hash-algorithm-cve-2011-4815/
[10]: /en/security/
