---
layout: news_post
title: "CVE-2017-10784: WEBrick の BASIC 認証におけるエスケープシーケンス挿入の脆弱性について"
author: "usa"
translator:
date: 2017-09-14 12:00:00 +0000
tags: security
lang: ja
---

Ruby の標準添付ライブラリである WEBrick で BASIC 認証を使用した場合、攻撃者により悪意のあるエスケープシーケンスをログに挿入されうる脆弱性が発見されました。
この脆弱性は、[CVE-2017-10784](http://cve.mitre.org/cgi-bin/cvename.cgi?name=CVE-2017-10784) として登録されています。

## 詳細

WEBrick において、BASIC 認証を使用した場合、ユーザー名として任意の文字列を渡すことができますが、この文字列がそのままログに出力されていました。
そのため、攻撃者は悪意のあるエスケープシーケンスをログに挿入することが可能となり、管理者がログを閲覧する際に、端末エミュレータで危険な制御文字を実行される可能性がありました。

この脆弱性は、[以前報告されて修正済みの脆弱性](https://www.ruby-lang.org/ja/news/2010/01/10/webrick-escape-sequence-injection/)に似ていますが、BASIC 認証の場合に、同様の問題が残っていました。

この問題の影響を受けるバージョンの Ruby のユーザーは、速やかに問題の修正されたバージョンに更新してください。

## 影響を受けるバージョン

* Ruby 2.2.7 以前の全ての Ruby 2.2 系列
* Ruby 2.3.4 以前の全ての Ruby 2.3 系列
* Ruby 2.4.1 以前の全ての Ruby 2.4 系列
* revision 58453 より前の開発版

## クレジット

この脆弱性情報は、Yusuke Endoh 氏 <mame@ruby-lang.org> によって報告されました。

## 更新履歴

* 2017-09-14 21:00:00 (JST) 初版
