---
layout: news_post
title: "CVE-2020-10933: socketライブラリのヒープ暴露脆弱性について"
author: "mame"
translator: "mame"
date: 2020-03-31 12:00:00 +0000
tags: security
lang: ja
---

socketライブラリにヒープ暴露の脆弱性が発見されました。
この脆弱性は [CVE-2020-10933](http://cve.mitre.org/cgi-bin/cvename.cgi?name=CVE-2020-10933) として登録されています。
ユーザのみなさんにはRubyを更新することを強くおすすめします。

## 詳細

`BasicSocket#recv_nonblock` や `BasicSocket#read_nonblock` をサイズやバッファ引数を指定して起動すると、これらのメソッドはまずバッファを指定サイズにリサイズします。操作がブロックする場合には、データを一切コピーせずにリターンします。その結果、バッファ文字列はヒープの中の任意のデータを含むことになります。これにより、インタプリタの中の機密データを暴露してしまうかもしれません。

この問題はLinuxでのみ悪用されます。この問題はRuby 2.5.0からあります。2.4系列は脆弱ではありません。

## 影響を受けるバージョン

* Ruby 2.5 系列: 2.5.7 およびそれ以前のバージョン
* Ruby 2.6 系列: 2.6.5 およびそれ以前のバージョン
* Ruby 2.7 系列: 2.7.0
* commit 61b7f86248bd121be2e83768be71ef289e8e5b90 より前の開発版

## クレジット

この脆弱性情報は、Samuel Williams 氏によって報告されました。

## 更新履歴

* 2020-03-31 21:00:00 (JST) 初版
