---
layout: news_post
title: "CVE-2022-28739: String から Float 変換時のバッファオーバーラン"
author: "mame"
translator: "jinroq"
date: 2022-04-12 12:00:00 +0000
tags: security
lang: ja
---

String から Float への変換アルゴリズムに、バッファオーバーランの脆弱性が発見されました。
この脆弱性は、[CVE-2022-28739](https://www.cve.org/CVERecord?id=CVE-2022-28739) として登録されています。
Ruby をアップグレードすることを強く推奨します。

## 詳細

String を Float に変換する内部関数のバグにより、`Kernel#Float` や `String#to_f` などの一部の変換メソッドでバッファのオーバーリードが発生する可能性があります。
典型的な結果はセグメンテーションフォールトによるプロセス終了ですが、限られた状況下では、不正なメモリ読み出しに悪用される可能性があります。

Ruby を 2.6.10、2.7.6、3.0.4、3.1.2 にアップデートしてください。

## 影響を受けるバージョン

* ruby 2.6.9 以前
* ruby 2.7.5 以前
* ruby 3.0.3 以前
* ruby 3.1.1 以前

## クレジット

この脆弱性情報は、[piao](https://hackerone.com/piao?type=user) 氏によって報告されました。

## 更新履歴

* 2022-04-12 21:00:00 (JST) 初版
