---
layout: news_post
title: "CVE-2022-28738: Regexp コンパイル時のダブルフリー"
author: "mame"
translator: "jinroq"
date: 2022-04-12 12:00:00 +0000
tags: security
lang: ja
---

Regexp コンパイル時に、ダブルフリーをする脆弱性が発見されました。
この脆弱性は、[CVE-2022-28738](https://www.cve.org/CVERecord?id=CVE-2022-28738) として登録されています。
Ruby をアップグレードすることを強く推奨します。

## 詳細

Regexp のコンパイル処理にバグがあり、細工したソース文字列で Regexp オブジェクトを作成すると、同じメモリが二度解放される可能性があります。これは「ダブルフリー」と呼ばれる脆弱性です。
一般的に、信頼できない入力から生成された Regexp オブジェクトを作成し、使用することは安全ではないと考えられています。しかしながら、今回のケースでは総合的に判断した結果、この問題を脆弱性として扱うことにしました。

Ruby を 3.0.4 または 3.1.2 に更新してください。

## 影響を受けるバージョン

* ruby 3.0.3 以前
* ruby 3.1.1 以前

なお、ruby 2.6 系列、2.7 系列は影響を受けません。

## クレジット

この脆弱性情報は、[piao](https://hackerone.com/piao?type=user) 氏によって報告されました。

## 更新履歴

* 2022-04-12 21:00:00 (JST) 初版
