---
layout: news_post
title: "CVE-2018-8780: Dir에서 NUL 문자 주입을 통한 의도하지 않은 디렉터리 접근 취약점"
author: "usa"
translator: "shia"
date: 2018-03-28 14:00:00 +0000
tags: security
lang: ko
---

`Dir`의 몇몇 메서드에서 디렉터리 명으로 넘겨진 인수 문자열에 NUL 문자를 삽입하는 것으로, 의도하지 않은 디렉터리에 접근할 수 있는 취약점이 발견되었습니다.
이 취약점은 CVE 아이디 [CVE-2018-8780](http://cve.mitre.org/cgi-bin/cvename.cgi?name=CVE-2018-8780)으로 할당되었습니다.

## 세부 내용

`Dir.open`, `Dir.new`, `Dir.entries`, `Dir.empty?`는 각자의 인수로 대상 디렉터리의 경로를 지정합니다.
만약 인수가 NUL(`\0`) 문자를 포함하는 경우, 이 메서드들은 NUL 문자 직전까지를 경로명으로 인식합니다.
그러므로 만약 외부 입력을 이 메서드들의 인수로 사용하는 경우, 공격자는 의도하지 않은 디렉터리에 접근할 수 있습니다.

해당 버전을 사용하는 모든 사용자는 즉시 업그레이드하기 바랍니다.

## 해당 버전

* 루비 2.2 버전대: 2.2.9 이하
* 루비 2.3 버전대: 2.3.6 이하
* 루비 2.4 버전대: 2.4.3 이하
* 루비 2.5 버전대: 2.5.0 이하
* 루비 2.6 버전대: 2.6.0-preview1
* 리비전 62989 이전의 트렁크

## 도움을 준 사람

이 문제는 [ooooooo_q](https://hackerone.com/ooooooo_q)가 보고했습니다.

## 수정 이력

* 2018-03-28 23:00:00 (KST) 최초 공개
