---
layout: news_post
title: "Переполнение буфера в модуле YAML для URI-закодированных строк (CVE-2014-2525)"
author: "hone and zzak"
translator: "Vlad Bokov"
date: 2014-03-29 01:49:25 +0000
tags: security
lang: ru
---

При парсинге URI-закодированной строки может произойти переполнение буфера в YAML.
Этой уязвимости присвоен номер
[CVE-2014-2525](http://www.ocert.org/advisories/ocert-2014-003.html).

## Подробнее

Всякий раз, когда YAML парсит строку с тегами, специально подготовленная строка может
вызвать переполнение буфера и выполнению произвольного кода.
Например:

{% highlight ruby %}
YAML.load <code_from_unknown_source>
{% endhighlight %}

## Затронутые версии

Ruby 1.9.3-p0 и новее используют psych в качестве парсера YAML по умолчанию.
Все версии модуля psych слинкованные с библиотекой libyaml `<= 0.1.5` подвержены атаке.

Проверить версию libyaml можно так:

{% highlight sh %}
$ ruby -rpsych -e 'p Psych.libyaml_version'
[0, 1, 5]
{% endhighlight %}

## Решение

Пользователи, установившие libyaml в систему, могут обновиться до версии `0.1.6`.
Во время пересборки Ruby надо указать на новую версию:

{% highlight sh %}
$ ./configure --with-yaml-dir=/path/to/libyaml
{% endhighlight %}

Пользователи, полагающиеся на встроенную версию, могут обновиться до версии
psych `2.0.5`, которая содержит libyaml `0.1.6`:

{% highlight sh %}
$ gem install psych
{% endhighlight %}

## История

* Изначально опубликовано 2014-03-29 01:49:25 UTC
* Обновлено 2014-03-29 09:37:00 UTC
