---
layout: news_post
title: "CVE-2020-10933: Уязвимость воздействия кучи в библиотеке сокетов"
author: "mame"
translator: "aleksandrilyin"
date: 2020-03-31 12:00:00 +0000
tags: security
lang: ru
---

В библиотеке сокетов была обнаружена уязвимость воздействия кучи.
Этой уязвимости назначен CVE идентификатор [CVE-2020-10933](http://cve.mitre.org/cgi-bin/cvename.cgi?name=CVE-2020-10933).
Мы строго рекомендуем обновить Ruby.

## Детали

Когда `BasicSocket#recv_nonblock` и `BasicSocket#read_nonblock` вызываются с параметрами size и buffer, они первоначально изменяют буфер до указанного размера. В тех случаях, когда операция блокируется, они возвращаются без копирования каких-либо данных. Таким образом, строка буфера теперь будет включать произвольные данные из кучи. Это может привести к появлению потенциально конфиденциальных данных от интерпретатора.

Эта проблема может быть использована только в Linux.  Эта проблема была начиная с Ruby 2.5.0; серия 2.4 не является уязвимой.

## Затронутые версии

* Серия Ruby 2.5: 2.5.7 и ранее
* Серия Ruby 2.6: 2.6.5 и ранее
* Серия Ruby 2.7: 2.7.0
* до master ревизии 61b7f86248bd121be2e83768be71ef289e8e5b90

## Благодарности

Спасибо Samuel Williams за обнаружение этой проблемы.

## История

* Оригинал опубликован 2020-03-31 12:00:00 (UTC)
