---
layout: news_post
title: "CVE-2019-15845：File.fnmatch 及 File.fnmatch? 存在 NUL 字节注入缺陷"
author: "mame"
translator: Delton Ding
date: 2019-10-01 11:00:00 +0000
tags: security
lang: zh_cn
---

Ruby 内置的 `File.fnmatch` 及 `File.fnmatch?` 存在 NUL 字节注入缺陷。能控制 path 模式参数的攻击者可利用此缺陷来绕过路径匹配。此缺陷的编号是 [CVE-2019-15845](https://cve.mitre.org/cgi-bin/cvename.cgi?name=CVE-2019-15845)。

## 细节

Ruby 内置的 `File.fnmatch` 及 `File.fnmatch?` 第一个参数是 path 模式参数。当此参数含有 NUL 字节（`\0`）时，会在 NUL 字节前立即结束匹配。所以接受外来输入的脚本，攻击者可以使其匹配错误的路径。

我们建议所有使用受影响版本的使用者尽速升级。

## 受影响的版本

* 所有 Ruby 2.3 及更早版本
* Ruby 2.4 系列： Ruby 2.4.7 及更早版本
* Ruby 2.5 系列： Ruby 2.5.6 及更早版本
* Ruby 2.6 系列： Ruby 2.6.4 及更早版本
* Ruby 2.7.0-preview1
* 早于 ruby master commit a0a2640b398cffd351f87d3f6243103add66575b 的全部版本

## 致谢

感谢 [ooooooo_q](https://hackerone.com/ooooooo_q) 发现此问题。

## 历史

* 最早发布于 2019-10-01 11:00:00 (UTC)
