---
layout: news_post
title: "CVE-2018-16396: 特定命令下受污染標記未能如實展開到 Array#pack 和 String#unpack 結果中"
author: "usa"
translator: "Delton Ding"
date: 2018-10-17 14:00:00 +0000
tags: security
lang: zh_tw
---

使用 `Array#pack` 和 `String#unpack` 處理某些特定格式時，原資料的受污染標記未能展開到返回的字串或陣列中。此缺陷已被分配 CVE 編號 [CVE-2018-16396](http://cve.mitre.org/cgi-bin/cvename.cgi?name=CVE-2018-16396)。

## 細節

`Array#pack` 方法將其接收的內容轉換成某一特定格式。當參數包含一些受污染的物件，返回的字串也應包含這些污染。`Array#unpack` 方法將參數展開成一個陣列，也應該將受污染的標記轉換到返回的陣列中。然而，當命令含有 `B`、`b`、`H` 和 `h` 時，污染標記並不會被展開。所以，如果你的腳本使用 `Array#pack` 和/或 `String#unpack` 來處理了不可靠的輸入後，嘗試檢查這些受污染標記時，檢查結果可能出錯。

所有受到影響的用戶請儘快升級。

## 受影響的版本

* Ruby 2.3 系列: 2.3.7 及更早版本
* Ruby 2.4 系列: 2.4.4 及更早版本
* Ruby 2.5 系列: 2.5.1 及更早版本
* Ruby 2.6 系列: 2.6.0-preview2 及更早版本
* 早於 r65125 的全部版本

## 鳴謝

感謝 [Chris Seaton](https://hackerone.com/chrisseaton) 回報了這一問題。

## 歷史

* 最早發佈於 2018-10-17 14:00:00 (UTC)
